{MCUT - Convers...}



UNIT convers;

INTERFACE

TYPE str6 = STRING[6];
     str10 = STRING[10];

PROCEDURE SendChannelMessage(ToHosts: BOOLEAN; Chan: INTEGER;Message: STRING; From: BYTE);
PROCEDURE SendTextToChannelUser(Chan: INTEGER; Text: STRING; From: str10; Senderch: BYTE);
PROCEDURE SendString(ch: BYTE; S: STRING);
FUNCTION AktUnixTime: LONGINT;
PROCEDURE HandleConv(ch: BYTE; S: STRING);
PROCEDURE StartConv(ch: BYTE; S: STRING);
PROCEDURE ConvCommand(ch: BYTE; S: STRING);
PROCEDURE ConvDisconnect(ch: BYTE);
PROCEDURE InitConv;
PROCEDURE AddOneUserAtChannel(Chan: INTEGER);
PROCEDURE DelOneUserAtChannel(Chan: INTEGER);
FUNCTION GetChannelFlags(Chan: INTEGER): WORD;
FUNCTION ConvTime: STRING;


IMPLEMENTATION

USES
DOS,TOOLBOX,CONVVAR,IADVAR,CRT
{$IFDEF CONVNETZ}
,CONVHOST
{$ENDIF}
{$IFDEF CONVNEU}
,CONVHNEU
{$ENDIF}
;


PROCEDURE SendString(ch: BYTE; S: STRING);
BEGIN
  inc(KS[ch]^.ConvData^.RX_Bytes,LENGTH(S));
  PutData(ch,S);
END;


{Frei definierbare Nachricht an alle User dieses Kanals schicken
 Auer an den User, der auf kanal 'From' eingeloggt ist}
PROCEDURE SendChannelMessage(ToHosts: BOOLEAN; Chan: INTEGER; Message: STRING; From: BYTE);
VAR tmp: pConvUserChan;
    b: BYTE;
    Found: BOOLEAN;
BEGIN
  FOR b := 0 TO 255 DO IF KS[b]<>NIL THEN IF (b<>From) AND (KS[b]^.status=6) THEN BEGIN
    tmp := KS[b]^.ConvData^.Channels;
    Found := FALSE;
    WHILE (tmp<>NIL) AND NOT Found DO BEGIN
      IF (tmp^.Channel=Chan) OR KS[b]^.ConvData^.Verb THEN BEGIN
        SendString(b,Message);
        Found := TRUE;
      END;
      tmp := tmp^.next;
    END;
  END;

  {Ping-Pong-Netz}
  {$IFDEF CONVNETZ}
  IF ToHosts THEN Host_CMSG_Cmd(0,'conversd',Chan,Message);
  {$ENDIF}
END;


PROCEDURE BenachrichtigeChannelUser_Disconnect(ch: BYTE; Chan: INTEGER; Wie: STRING);
VAR b: BYTE;
    tmp: pConvUserChan;
    S: STRING;
BEGIN
  STR(Chan,S);
  S := '*** ('+ConvTime+') '+KS[ch]^.ConvData^.Call+'@'+KS[ch]^.ConvData^.Host+' left channel '+S+' ('+Wie+')';
  FOR b := 0 TO 255 DO IF KS[b]<>NIL THEN BEGIN
    IF (KS[b]^.status=6) AND (b<>ch) THEN BEGIN
      tmp := KS[b]^.ConvData^.Channels;
      WHILE (tmp<>NIL) DO BEGIN
         IF (tmp^.Channel=Chan) OR KS[b]^.ConvData^.Verb THEN SendString(b,S+#13);
         tmp := tmp^.Next;
      END;
    END;
  END;
{$IFDEF CONVNETZ}
  Host_USER_Cmd(0,KS[ch]^.ConvData^.Call,OwnConvData^.Hostname,AktUnixTime,Chan,-1,Wie);
{$ENDIF}
END;


FUNCTION GetChannelFlags(Chan: INTEGER): WORD;
VAR tmp: pChanRec;
    Found: BOOLEAN;
BEGIN
  tmp := ChannelDatRoot;
  Found := FALSE;

  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Channel=Chan THEN BEGIN
      Found := TRUE;
      GetChannelFlags := tmp^.Flags;
    END;
    tmp := tmp^.Next;
  END;
END;



FUNCTION TimeLong(sec: LONGINT): STRING;
VAR S,Hlp: STRING;
    rest,min,hour,days: LONGINT;
BEGIN
  rest := sec;

  sec := rest MOD 60;
  rest := rest DIV 60;
  min := rest MOD 60;
  rest := rest DIV 60;
  hour := rest MOD 60;
  rest := rest DIV 60;
  days := rest;

  S := '';
  IF days>0 THEN BEGIN
    IF days=1 THEN S := ' 1 day, '
    ELSE BEGIN
      STR(days,Hlp);
      S := Hlp + ' days,';
    END;
  END;
  IF hour>0 THEN BEGIN
    IF hour=1 THEN S := S + ' 1 hour, '
    ELSE BEGIN
      STR(hour,Hlp);
      S := S + Hlp + ' hours,';
    END;
  END;
  IF min>0 THEN BEGIN
    IF min=1 THEN S := S + ' 1 minute, '
    ELSE BEGIN
      STR(min,Hlp);
      S := S + Hlp + ' minutes,';
    END;
  END;
  IF sec=1 THEN S := S + ' 1 second'
  ELSE BEGIN
    STR(sec,Hlp);
    S := S + Hlp + ' seconds';
  END;
  TimeLong := S;
END;



FUNCTION ConvTime: STRING;
VAR Std,Min,Sec,Sec100: WORD;
    SStd,SMin: STRING[2];
BEGIN
  GetTime(Std,Min,Sec,Sec100);
  STR(Std,SStd);
  STR(Min,SMin);
  IF LENGTH(SStd)=1 THEN SStd := '0'+SStd;
  IF LENGTH(SMin)=1 THEN SMin := '0'+SMin;
  ConvTime := SStd + ':' + SMin;
END;



{Sucht das letzte Vorkommen des angegebenen Zeichens im String}
FUNCTION Last(Zeichen: CHAR; S: STRING): BYTE;
VAR i: BYTE;
BEGIN
  i := LENGTH(S);
  WHILE i>0 DO BEGIN
    IF S[i]=Zeichen THEN BEGIN
      Last := i;
      Exit;
    END;
    dec(i);
  END;
  IF i=0 THEN i := LENGTH(S);
  Last := i;
END;



PROCEDURE SendTextToChannelUser(Chan: INTEGER; Text: STRING; From: str10; Senderch: BYTE);
VAR tmp: pConvUserChan;
    b: BYTE;
    S,Hlp: STRING;
    text2:STRING;
BEGIN
  {Ping-Pong-Netz}
  {$IFDEF CONVNETZ}
  Host_CMSG_Cmd(Senderch,From,Chan,Text);
  {$ENDIF}

  {MCuT-Netz}
  {$IFDEF CONVNEU}
  CMD_CMSG(OwnConvData^.Hostname,AktUnixTime,From,Chan,Text,0);
  {$ENDIF}


  FOR b := 0 TO 255 DO IF KS[b]<> NIL THEN BEGIN
    IF KS[b]^.status=6 THEN BEGIN
      tmp := KS[b]^.ConvData^.Channels;

      WHILE tmp<>NIL DO BEGIN
        text2:=text;
        IF (tmp^.Channel=Chan) AND (b<>SenderCh) THEN BEGIN
          IF Chan<>KS[b]^.ConvData^.AktChan THEN BEGIN
            STR(Chan,S);
            S := '<'+S+':'+From+'>: ';
          END
          ELSE S := '<'+From+'>: ';
          IF From<>'conversd' THEN text2 := S + text2;
          REPEAT
            Hlp := COPY(text2,1,KS[b]^.ConvData^.Spalten);
            IF (POS(' ',Hlp)>0) AND (LENGTH(text2)>KS[b]^.ConvData^.Spalten) THEN
              Hlp := COPY(Hlp,1,Last(' ',Hlp)-1);
            SendString(b,Hlp+#13);
            text2 := StringD(' ',LENGTH(S)-1)+COPY(text2,LENGTH(Hlp)+1,255);
          UNTIL LTRIM(text2)='';
        END;
        tmp := tmp^.Next;
      END;
    END;
  END;
END;


{Schickt eine Nachricht als Usermail an einen User.
 Rckgabe: TRUE, wenn user eingeloggt, FALSE wenn nicht}
FUNCTION SendTextToUser(Call: str6; Text: STRING; ch: BYTE): BOOLEAN;
VAR tmp: pConvUserChan;
    b: BYTE;
    S,Hlp: STRING;
    {$IFDEF CONVNETZ}
    tmp2: pExtUser;
    {$ENDIF}
BEGIN
  SendTextToUser := FALSE;
  FOR b := 0 TO 255 DO IF KS[b]<> NIL THEN IF (KS[b]^.status=6) AND (b<>ch) THEN BEGIN
    IF KS[b]^.ConvData^.Call=Call THEN BEGIN
      SendTextToUser := TRUE;
      IF KS[b]^.ConvData^.Away THEN SendString(ch,'*** ('+ConvTime+') '+Call+' is away: '+KS[b]^.ConvData^.AwayText+#13);
      S := Text;
      IF LENGTH(S)<=70 THEN SendString(b,'<*'+KS[ch]^.ConvData^.Call+'*>: '+S+#13)
      ELSE BEGIN
        REPEAT
          Hlp := COPY(S,1,65);
          Hlp := COPY(Hlp,1,Last(' ',Hlp)-1);
          S := COPY(S,LENGTH(Hlp)+1,255);
          SendString(b,'<*'+KS[ch]^.ConvData^.Call+'*>: '+Hlp+#13);
        UNTIL S='';
      END;
    END;
  END;

{$IFDEF CONVNETZ}
  tmp2 := ExtUserRoot;
  WHILE tmp2<>NIL DO BEGIN
    IF tmp2^.Call=Call THEN BEGIN
      SendTextToUser := TRUE;
      Host_UMSG_Cmd(0,KS[ch]^.ConvData^.Call,Call,GetHostChannel(tmp2^.Via_Host),Text);
    END;
    tmp2 := tmp2^.next;
  END;
{$ENDIF}
END;



FUNCTION AktUnixTime: LONGINT;
VAR DT: DateTime;
    dummy: WORD;
BEGIN
  WITH DT DO BEGIN
    getdate(Year,Month,Day,dummy);
    gettime(Hour,Min,Sec,dummy);

    AktUnixTime := calc_ixtime(Day,Month,Year-1900,Hour,Min,Sec);
  END;
END;


{$IFDEF CONVNETZ}
PROCEDURE AddConvLink(Hostname: str15; Trusted: BOOLEAN; Pfad: STRING);
VAR tmp: pHostListe;
BEGIN
  tmp:=HostDataRoot;
  IF tmp=NIL THEN BEGIN
    new(HostDataRoot);
    tmp:=HostDataRoot;
  END
  ELSE BEGIN
    tmp:=HostDataRoot;
    WHILE tmp^.next<>NIL DO tmp:=tmp^.next;
    New(tmp^.Next);
    tmp:=tmp^.Next;
  END;

  tmp^.Next := NIL;
  tmp^.Hostname := HostName;
  tmp^.State := 0;
  tmp^.RX_Qual := 0;
  tmp^.TX_Qual := 0;
  tmp^.LastPing := 0;
  tmp^.Flags := 0;
  tmp^.Since := AktUnixTime;
  tmp^.Tries := 0;
  tmp^.Trusted := Trusted;
  tmp^.RX_Bytes := 0;
  tmp^.TX_Bytes := 0;
  tmp^.Pfad := Pfad;
  tmp^.Chan := 0;
END;


PROCEDURE DelConvLink(Hostname: str15);
VAR tmp,last: pHostListe;
    Found: BOOLEAN;
    tmp3,tmp4,last2:pExtUser;

  {User auf dem Link aus der Liste lschen}
  PROCEDURE ReleaseUsers;
  BEGIN
    IF tmp^.state>0 THEN
    BEGIN
      KS[tmp^.chan]^.FLAGS:=KS[tmp^.chan]^.FLAGS OR KS_DISCREQ;
      tmp3 := ExtUserRoot;
      last2 := NIL;
      WHILE tmp3<>NIL DO BEGIN
        IF tmp3^.Via_Host=hostname THEN BEGIN
          BenachrichtigeChannelUser_Disconnect(tmp^.chan,tmp3^.Channel,OwnConvData^.Hostname+
                                               '<>'+tmp3^.Via_Host+' link killed');
          IF last2<>NIL THEN BEGIN
            last2^.next := tmp3^.next;      {Diesen Eintrag berspringen}
            tmp4 := tmp3;
            tmp3 := tmp3^.next;
            dispose(tmp4);
          END
          ELSE BEGIN
            ExtUserRoot := tmp3^.next;
            tmp4 := tmp3;
            dispose(tmp4);
          END;
        END
        ELSE BEGIN
          last2 := tmp3;
          tmp3 := tmp3^.next;
        END;
      END;
      DISPOSE(KS[tmp^.chan]^.convHost);
      KS[tmp^.chan]^.ConvHost:=NIL;
      KS[tmp^.chan]^.Status:=111;
    END;
  END;

BEGIN
  tmp := HostDataRoot;
  Found := FALSE;
  last := NIL;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Hostname=Hostname THEN BEGIN
      IF last=NIL THEN HostDataRoot := tmp^.next
                  ELSE last^.next := tmp^.next;
      ReleaseUsers;
      dispose(tmp);
      IF last=NIL THEN HostDataRoot:=NIL;
      found := TRUE;
    END
    ELSE BEGIN
      last := tmp;
      tmp := tmp^.next;
    END;
  END;

END;


PROCEDURE SaveConvLinksInFile;
VAR LnkF: FILE OF tConvLinkFile;
    Lnk: tConvLinkFile;
    tmp: pHostListe;
BEGIN
  ASSIGN(LnkF,QRVPath+'CONV.LNK');
  {$I-}
  REWRITE(LnkF);
  {$I+}
  IF IOResult<>0 THEN Exit;
  tmp := HostDataRoot;
  WHILE tmp<>NIL DO BEGIN
    Lnk.Hostname := tmp^.Hostname;
    Lnk.Pfad := tmp^.Pfad;
    Lnk.Trusted := tmp^.Trusted;
    WRITE(LnkF,Lnk);
    tmp := tmp^.next;
  END;
  CLOSE(LnkF);
END;
{$ENDIF}


{Convers-Initialisierung - NUR EINMAL BEIM START VON MCUT AUFRUFEN!}
PROCEDURE InitConv;
VAR f: Text;
    S,Hlp: STRING;
    {$IFDEF CONVNETZ}
    LnkF: FILE OF tConvLinkFile;
    Lnk: tConvLinkFile;
    {$ENDIF}
    UserF: FILE OF tConvUserDataFile;
    DS: tConvUserDataFile;
    ch: CHAR;
    dummy: BOOLEAN; B:BYTE;
BEGIN
  WRITELN('Reading convers-configuration...');
{$IFNDEF FPK} (* we do not store user-data, until typed-file support is ready*)
  ASSIGN(Userf,QRVPath+'CONVUSER.MCT');
  {$I-}
  RESET(Userf);
  {$I+}
  IF IOResult=0 THEN BEGIN
    dummy := FALSE;
    IF NOT EOF(Userf) THEN BEGIN
      READ(UserF,DS);
      IF DS.Call<>UserFileVers THEN BEGIN
        WRITELN('CONVUSER.MCT ist veraltet (falsche Struktur).');
        WRITELN('Der Convers luft so nicht mehr stabil! Die Datei mu gelscht oder');
        WRITELN('konvertiert werden, damit MCUT startet.');
        WRITE('Lschen? (J/N) ');
        REPEAT
          ch := UpCase(READKEY);
          IF ch=#0 THEN BEGIN
            ch := READKEY;
            ch := ' ';
          END;
        UNTIL (ch='J') OR (ch='N');
        IF ch='N' THEN Halt;
        dummy := TRUE;
      END;
    END;
    CLOSE(Userf);
    IF dummy THEN BEGIN
    {$I-}
    ERASE(Userf);
    {$I+}
    IF IOResult=0 THEN BEGIN END;
    END;
  END;

{$ENDIF}
  ChannelDatRoot := NIL;
  {$IFDEF CONVNETZ}
  HostDataRoot := NIL;
  ExtUserRoot := NIL;
  DestiRoot := NIL;
  {$ENDIF}

  NEW(OwnConvData);
  OwnConvData^.HostName := 'noname';
  OwnConvData^.StartupTime := AktUnixTime;

  {Konfiguration aus CONV.CFG lesen}
  ASSIGN(f,QRVPath+'CONV.CFG');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult=0 THEN BEGIN
    WHILE NOT EOF(f) DO BEGIN
      READLN(f,S);
      S := LTRIM(RTRIM(OnlyOneSpace(S)));
      IF (COPY(S,1,1)<>'#') AND (LENGTH(S)>0) THEN BEGIN
        Hlp := Gross(COPY(S,1,POS(' ',S)-1));
        S := COPY(S,POS(' ',S)+1,255);
        IF Hlp='HOSTNAME' THEN OwnConvData^.Hostname := Klein(S);
      END;
    END;
    CLOSE(f);
  END;


{$IFDEF CONVNETZ}
  {Eingetragene Links aus CONV.LNK}
{$IFNDEF FPK}
  ASSIGN(LnkF,QRVPath+'CONV.LNK');
  {$I-}
  RESET(LnkF);
  {$I+}
  IF IOResult=0 THEN BEGIN
    WHILE NOT EOF(LnkF) DO BEGIN
      READ(LnkF,Lnk);
      AddConvLink(Lnk.HostName,Lnk.Trusted,Lnk.Pfad);
    END;
    CLOSE(LnkF);
  END;
{$ENDIF}   
{$ENDIF}

END;



{Gucken, ob ein Kanal schon existiert. Wenn ja wird die Anzahl User
 zurck gegeben}
FUNCTION ExistChannel(chan: INTEGER; VAR user: WORD): BOOLEAN;
VAR tmp: pChanRec;
    Found: BOOLEAN;
BEGIN
  tmp := ChannelDatRoot;
  user := 0;

  Found := FALSE;
  WHILE (tmp <> NIL) AND NOT Found DO BEGIN
    IF tmp^.Channel=Chan THEN BEGIN
      Found := TRUE;
      user := tmp^.Users;
    END;
    tmp := tmp^.Next;
  END;
  ExistChannel := Found;
END;


{Eine User hat auf dem Kanal eingeloggt - Anzahl User um 1 erhhen}
PROCEDURE AddOneUserAtChannel(Chan: INTEGER);
VAR tmp: pChanRec;
BEGIN
  {Test, ob der Kanal schon eingetragen ist. wenn ja -> einfach den
   Zhler 1 hoch setzen}
  tmp := ChannelDatRoot;
  WHILE tmp<>NIL DO BEGIN
    IF tmp^.Channel=Chan THEN BEGIN
      inc(tmp^.Users);
      Exit;
    END;
    tmp := tmp^.next;
  END;

  tmp:=ChannelDatRoot;
  IF tmp=NIL THEN BEGIN
    new(ChannelDatRoot);
    tmp:=ChannelDatRoot;
  END
  ELSE BEGIN
    tmp:=ChannelDatRoot;
    WHILE tmp^.next<>NIL DO tmp:=tmp^.next;
    New(tmp^.Next);
    tmp:=tmp^.Next;
  END;

  tmp^.Next := NIL;
  tmp^.Channel := Chan;
  tmp^.Flags := 0;
  tmp^.Users := 1;
  tmp^.Topic := '';
END;



PROCEDURE DelOneUserAtChannel(Chan: INTEGER);
VAR tmp,last: pChanRec;
    Found: BOOLEAN;
BEGIN
  tmp := ChannelDatRoot;
  last := NIL;

  Found := FALSE;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Channel=Chan THEN BEGIN
      dec(tmp^.Users);
      Found := TRUE;
    END
    ELSE BEGIN
      last := tmp;
      tmp := tmp^.next;
    END;
  END;

  IF tmp^.users=0 THEN BEGIN
    {Gucken, ob dies der einzige aktive Kanal ist
     wenn ja -> weg machen}
    IF ChannelDatRoot^.next=NIL THEN BEGIN
      dispose(ChannelDatRoot);
      ChannelDatRoot := NIL;
    END
    ELSE BEGIN
      IF last=NIL THEN ChannelDatRoot := tmp^.next
                  ELSE last^.next := tmp^.next;
      dispose(tmp);
    END;
  END;
END;


{einen Kanal in der Kanal-Liste eines Users lschen}
FUNCTION DelOneUser(ch: BYTE; Chan: INTEGER): BOOLEAN;
VAR tmp,last,tmp2: pConvUserChan;
    Found: BOOLEAN;
    Root: pConvUserChan;
BEGIN
  tmp := KS[ch]^.ConvData^.Channels;

  {Gucken, ob der User nur in einem Kanal ist. Wenn ja mu der gewnschte
   Kanal ja dieser eine sein.}
  IF tmp^.next=NIL THEN BEGIN
    DISPOSE(KS[ch]^.ConvData^.Channels);
    DelOneUser := TRUE;
    Exit;
  END;

  {Der User ist in mehreren Kanlen eingeloggt. Diesen einen 'rausfinden
   und disposen}
  Found := FALSE;
  last := NIL;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Channel=Chan THEN BEGIN
      IF last=NIL THEN KS[ch]^.ConvData^.Channels := tmp^.next
                  ELSE last^.next := tmp^.next;
      dispose(tmp);
      found := TRUE;
    END
    ELSE BEGIN
      last := tmp;
      tmp := tmp^.next;
    END;
  END;
  DelOneUser := FALSE;

END;


{Aktuelles Topic des angegebenen Kanals holen}
FUNCTION GetChannelTopic(Chan: INTEGER): STRING;
VAR tmp: pChanRec;
    Found: BOOLEAN;
BEGIN
  tmp := ChannelDatRoot;
  Found := FALSE;
  GetChannelTopic := '';

  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Channel=Chan THEN BEGIN
      Found := TRUE;
      GetChannelTopic := tmp^.Topic;
    END;
    tmp := tmp^.Next;
  END;
END;


{Persnliche Daten von der Platte holen}
FUNCTION GetPersData(Call: str6; VAR Pers: str127; VAR Spalten: BYTE): BOOLEAN;
VAR F: FILE OF tConvUserDataFile;
    DS: tConvUserDataFile;
    Found: BOOLEAN;
BEGIN
  Pers := '';
  Spalten := 78;
  Found := FALSE;
  GetPersData := FALSE;
{$IFNDEF FPK}
  ASSIGN(f,QRVPath+'CONVUSER.MCT');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult<>0 THEN Exit;

  WHILE NOT EOF(f) AND NOT Found DO BEGIN
    READ(f,DS);
    IF DS.Call=Call THEN BEGIN
      Found := TRUE;
      Pers := DS.Pers;
      Spalten := DS.Spalten;
    END;
  END;
  CLOSE(f);
  GetPersData := Found;
   {$ENDIF}
END;


{Anzahl User auf angegebenem Kanal holen}
FUNCTION GetUserChanAnz(Chan: INTEGER): WORD;
VAR tmp: pChanRec;
    Found: BOOLEAN;
BEGIN
  tmp := ChannelDatRoot;
  Found := FALSE;

  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Channel=Chan THEN BEGIN
      Found := TRUE;
      GetUserChanAnz := tmp^.Users;
    END;
    tmp := tmp^.Next;
  END;
END;


{Testet, ob ein User in einem bestimmten Kanal eingeloggt ist.}
FUNCTION IsEingeloggt(ch: BYTE; Chan: INTEGER): BOOLEAN;
VAR tmp: pConvUserChan;
    Found: BOOLEAN;
BEGIN
  Found := FALSE;
  tmp := KS[ch]^.ConvData^.Channels;

  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Channel = Chan THEN Found := TRUE;
    tmp := tmp^.Next;
  END;
  IsEingeloggt := Found;
END;


{einen Kanal in der kanal-liste eines Users lschen.
 Rckgabe: TRUE, wenns der letzte zu verlassende Kanal war (convers-ende)
           FALSE, wenn der User noch im Convers ist}
FUNCTION DelUserChan(ch: BYTE; Chan: INTEGER): BOOLEAN;
VAR tmp,last: pConvUserChan;
BEGIN
  tmp := KS[ch]^.ConvData^.Channels;
  last := NIL;

  WHILE (tmp<>NIL) DO BEGIN
    IF tmp^.Channel=Chan THEN BEGIN
      IF last=NIL THEN BEGIN
        KS[ch]^.ConvData^.Channels := NIL;
        dispose(tmp);
        DelUserChan := TRUE;
        Exit;
      END
      ELSE BEGIN
        last^.next := tmp^.next;
        dispose(tmp);
        DelUserChan := FALSE;
        Exit;
      END;
    END
    ELSE BEGIN
      last := tmp;
      tmp := tmp^.Next;
    END;
  END;
END;




FUNCTION Hoch(Basis,Exponent: WORD): LONGINT;
VAR i: WORD;
    Erg: LONGINT;
BEGIN
  Erg := Basis;
  FOR i := 2 TO Exponent DO Erg := Erg * Basis;
  Hoch := Erg;
END;


{Bei einem Kanal einloggen.}
PROCEDURE Login2Channel(ch: BYTE; AktChan: INTEGER);
VAR StandardFlags: BYTE;
    b: BYTE;
    S,Hlp: STRING;
    OK: BOOLEAN;
    AnzUser: WORD;
    tmp,tmp2: pConvUserChan;
    User: STRING[8];
    Host: STRING[15];
    Pers: STRING[127];
    AllreadyOnThisChannel: BOOLEAN;
    ChanFlags: WORD;
BEGIN

  User := KS[ch]^.ConvData^.Call;
  Host := KS[ch]^.ConvData^.Host;

  IF AktChan>32767 THEN BEGIN
    SendString(ch,'*** ('+ConvTime+') Wrong channel-number (only 0..32767 permitted).'+#13);
    Exit;
  END;

  IF NOT AllreadyOnThisChannel THEN BEGIN
    ChanFlags := GetChannelFlags(AktChan);
    IF (ChanFlags AND PRIVAT>0) AND (KS[ch]^.ConvData^.LastInviChan<>AktChan) THEN BEGIN
      STR(AktChan,Hlp);
      SendString(ch,'*** ('+ConvTime+') You need an inventation to join the private channel '+Hlp+'.'+#13);
      SendChannelMessage(TRUE,AktChan,'*** ('+ConvTime+') '+KS[ch]^.ConvData^.Call+'@'+OwnConvData^.Hostname+
                                      ' tries to join your private channel.'+#13,ch);
      Exit;
    END;
  END;

  KS[ch]^.ConvData^.AktChan := AktChan;

  {Erstmal Testen, ob der User vielleicht schonmal auf diesem Kanal ist.}
  tmp := KS[ch]^.ConvData^.Channels;
  AllreadyOnThisChannel := FALSE;
  WHILE (tmp<>NIL) AND NOT AllreadyOnThisChannel DO BEGIN
    IF tmp^.Channel=AktChan THEN AllreadyOnThisChannel := TRUE;
    tmp := tmp^.Next;
  END;


  IF NOT AllreadyOnThisChannel THEN AddOneUserAtChannel(AktChan);
  OK := ExistChannel(AktChan,AnzUser);


  STR(AktChan,Hlp);

  {Wieviele Leute sind noch eingeloggt?}
  StandardFlags := 0;
  IF AnzUser=1 THEN BEGIN
    SendString(ch,'*** You created a new channel '+Hlp+'.'+#13);
    IF AktChan<>0 THEN BEGIN
      SendString(ch,'*** ('+ConvTime+') conversd made you a channel OperatorFlag for channel '+Hlp+#13);
      StandardFlags := StandardFlags OR IS_CHANOP;
    END;
  END
  ELSE BEGIN
    STR(AnzUser,S);
    SendString(ch,'*** ('+ConvTime+') You are now talking to channel '+Hlp+'. There are '+S+' users.'+#13);
  END;

  {Topic}
  Hlp := GetChannelTopic(AktChan);
  IF Hlp<>'' THEN SendString(ch,'*** current Topic is: '+Hlp+#13);

  {User-Info holen}
  IF KS[ch]^.ConvData^.Channels=NIL THEN BEGIN
    OK := GetPersData(User,KS[ch]^.ConvData^.Pers,KS[ch]^.ConvData^.Spalten);
    IF OK THEN SendString(ch,'*** Personal text and data set.'+#13)
          ELSE SendString(ch,'*** No personal text set.'+#13);
  END;


  IF NOT AllreadyOnThisChannel THEN BEGIN

    {********* Andere User auf diesem Kanal benachrichtigen *********}
    Pers := KS[ch]^.ConvData^.Pers;
    STR(AktChan,Hlp);
    ChanFlags := GetChannelFlags(AktChan);
    S := '*** ('+ConvTime+') '+User+'@'+Host+' joined ';
    IF ChanFlags AND SECRET>0 THEN S := S + ' secret ';
    IF ChanFlags AND INVISIBLE>0 THEN S := S + ' invisible ';
    S := S + 'channel '+Hlp;
    IF LENGTH(Pers)>0 THEN S := S + #13 + '    ('+Pers+')';


    FOR b := 0 TO 255 DO IF KS[b]<> NIL THEN BEGIN
      IF KS[b]^.status=6 THEN BEGIN
        tmp := KS[b]^.ConvData^.Channels;

        WHILE tmp<>NIL DO BEGIN
          IF ((tmp^.Channel=AktChan) OR KS[b]^.ConvData^.Verb) AND (ch<>b) THEN SendString(b,S+#13);
          tmp := tmp^.Next;
        END;
      END;
    END;


    {********** angegebenen Kanal in die Liste des Users eintragen *********}
    tmp:=KS[ch]^.ConvData^.Channels;
    IF tmp=NIL THEN BEGIN
      new(KS[ch]^.ConvData^.Channels);
      tmp:=KS[ch]^.ConvData^.Channels;
    END
    ELSE BEGIN
      tmp:=KS[ch]^.ConvData^.Channels;
      WHILE tmp^.next<>NIL DO tmp:=tmp^.next;
      New(tmp^.Next);
      tmp:=tmp^.Next;
    END;
    tmp^.Next := NIL;
    tmp^.Channel := AktChan;
    IF (KS[ch]^.FLAGS AND KS_SysOp)<>0 THEN
       KS[ch]^.ConvData^.OperatorFlag := TRUE
    ELSE
       KS[ch]^.ConvData^.OperatorFlag := FALSE;
    tmp^.Flags := StandardFlags;
    IF tmp^.Flags AND IS_CHANOP>0 THEN tmp^.From_Oper := 'conversd';
    tmp^.Login := AktUnixTime;
    KS[ch]^.ConvData^.LastText := tmp^.Login;

  {$IFDEF CONVNETZ}
    IF KS[ch]^.ConvData^.Pers='' THEN S := '@'
                                 ELSE S := KS[ch]^.ConvData^.Pers;
    Host_USER_Cmd(0,KS[ch]^.ConvData^.Call,OwnConvData^.Hostname,tmp^.Login,-1,tmp^.Channel,S);
  {$ENDIF}
  END;  {AllreadyOnThisChannel}
END;


{Eine Station loggt in den Convers ein.}
PROCEDURE StartConv(ch: BYTE; S: STRING);
VAR tmp: WORD;
{$IFDEF CONVNETZ}
    f: Text;
{$ENDIF}
BEGIN
  IF KS[ch]=NIL THEN exit;
  {$IFDEF CONVNETZ}
    PutData(ch,'MCUT-Ping-Pong-Convers, type /login [channel] to join in'+#13);

    ASSIGN(f,QRVPath+'CTEXT.CVS');
    {$I-}
    RESET(f);
    {$I+}
    IF IOResult=0 THEN BEGIN
      WHILE NOT EOF(f) DO BEGIN
        READLN(f,S);
        PutData(ch,S+#13);
      END;
      CLOSE(f);
    END;
    KS[ch]^.status := 101;
    KS[ch]^.LastStatus := KS[ch]^.status;
  {$ELSE}
  NEW(KS[ch]^.ConvData);

  KS[ch]^.ConvData^.LastStatus:=KS[ch]^.status;
  KS[ch]^.LastStatus := KS[ch]^.status;
  KS[ch]^.status:=6;

  WITH KS[ch]^.ConvData^ DO BEGIN
    {Kanal, in den eingeloggt werden soll, 'rausfinden}
    VAL(S,AktChan,tmp);
    IF tmp <> 0 THEN AktChan := 0;

    Channels := NIL;
    Call := CutSSID(KS[ch]^.Call);
    call := Klein(call);
    Host := Klein(OwnConvData^.HostName);
    Via_Host := '';
    Away := FALSE;
    AwayText := '';
    Verb := FALSE;
    LastInviChan := 0;
    RX_Bytes := 0;
    TX_Bytes := 0;
    {$IFDEF CONVNEU}
      ID := MakeID(OwnConvData^.HostName,Call);
    {$ENDIF}


    S := 'conversd @ '+OwnConvData^.Hostname+' MCUT-'+WhatIsThis+' '+ConvRelease+' - Type /HELP for help.';
    SendString(ch,S+#13);
    Login2Channel(ch,AktChan);
  END;
  {$ENDIF}
END;



{Kanal wechseln bzw. nochmal in einen bestehenden einloggen}
PROCEDURE Channel(ch: BYTE; S: STRING);
VAR Chan: INTEGER;
    code: WORD;
    tmp: pConvUserChan;
    AlsoConnected: BOOLEAN;
    AnzUsr: WORD;
    Hlp,aLine: STRING;
BEGIN
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  IF S[0]=#0 THEN BEGIN
    STR(KS[ch]^.ConvData^.AktChan,S);
    AnzUsr := GetUserChanAnz(KS[ch]^.ConvData^.AktChan);

    SendString(ch,'*** ('+ConvTime+') You are talking on channel '+S);
    IF AnzUsr=1 THEN S := 'You are alone'
    ELSE BEGIN
      STR(AnzUsr,S);
      S := 'There are '+S+' users.';
    END;
    SendString(ch,' '+S+#13);

    AlsoConnected := FALSE;
    tmp := KS[ch]^.ConvData^.Channels;
    WHILE (tmp<>NIL) DO BEGIN
      IF tmp^.Channel<>KS[ch]^.ConvData^.AktChan THEN BEGIN
        IF NOT AlsoConnected THEN BEGIN
          Hlp := '*** Also attached:';
          AlsoConnected := TRUE;
        END;
        STR(tmp^.Channel,S);
        aLine := ' channel '+S+' (';
        AnzUsr := GetUserChanAnz(tmp^.Channel);
        STR(AnzUsr,S);
        IF AnzUsr=1 THEN aLine := aLine + '1 user)'
                    ELSE aLine := aLine + S + ' users)';
        IF LENGTH(Hlp)+LENGTH(aLine)<=78 THEN BEGIN
          Hlp := Hlp + aLine;
        END
        ELSE BEGIN
          SendString(ch,Hlp+#13);
          Hlp := '    '+aLine;
        END;
      END;
      tmp := tmp^.Next;
    END;
    IF LENGTH(Hlp)>0 THEN SendString(ch,Hlp+#13);
    Exit;
  END;

  VAL(S,Chan,code);
  IF code<>0 THEN BEGIN
    SendString(ch,'*** Syntax error'+#13);
    Exit;
  END;

  IF Chan=KS[ch]^.ConvData^.AktChan THEN BEGIN
    STR(Chan,S);
    SendString(ch,'*** ('+ConvTime+') Already on channel '+S+'.'+#13);
    Exit;
  END;

  Login2Channel(ch,Chan);
END;



{Kanal verlassen}
PROCEDURE Leave(ch: BYTE; S: STRING);
VAR OK,Last: BOOLEAN;
    Chan: INTEGER;
    code: WORD;
BEGIN
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  IF S='' THEN Chan := KS[ch]^.ConvData^.AktChan
  ELSE BEGIN
    VAL(S,Chan,code);
    IF code<>0 THEN BEGIN
       SendString(ch,'*** Channel-Number missing'+#13);
       Exit;
    END;
  END;

  IF NOT IsEingeloggt(ch,Chan) THEN BEGIN
    SendString(ch,'*** ('+ConvTime+') You were not on channel '+S+'.'+#13);
    Exit;
  END;

  {Die anderen User benachrichtigen, das diese Station den kanal verlassen
   hat}
  BenachrichtigeChannelUser_Disconnect(ch,Chan,'/leave');

  {Den Kanal in der Kanal-Liste des Users streichen. Wenn es der einzige
   war, wird Last auf TRUE gesetzt.}
  Last := DelOneUser(ch,Chan);

  DelOneUserAtChannel(Chan);

  IF Last THEN BEGIN
    KS[ch]^.status := KS[ch]^.ConvData^.LastStatus;
    DISPOSE(KS[ch]^.ConvData);
    KS[ch]^.ConvData := NIL;
    IF KS[ch]^.LastStatus=0 THEN
       KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ
    ELSE
       SendString(ch,#13+'Convers session terminated'+#13#13);
    Exit;
  END
  ELSE BEGIN
    STR(Chan,S);
    SendString(ch,'*** ('+ConvTime+') left channel '+S+'.'+#13);
    Chan := KS[ch]^.ConvData^.Channels^.Channel;
    STR(Chan,S);
    KS[ch]^.ConvData^.AktChan := Chan;
    SendString(ch,'*** You are now talking on channel '+S+'.'+#13);
  END;
END;


{Versions-Info}
PROCEDURE Version(ch: BYTE);
BEGIN
  SendString(ch,'*** conversd MCUT-'+WhatIsThis+'-Release '+ConvRelease+#13);
  SendString(ch,'    written by Jochen Sarrazin, <sarrazin@muenster.de>. '+#13);
  SendString(ch,'    now maintained by me <hzorn@ix.urz.uni-heidelberg.de>'+#13);
  {$IFNDEF CONVNETZ}
  SendString(ch,'    Compiled _without_ network-support.'+#13);
  {$ELSE}
  SendString(ch,'    Compiled with PingPong-Support. WARNING: This is VERY experimental'+#13);
  {$ENDIF}
END;



FUNCTION MakeStrZeit(Zeit: LONGINT): STRING;
VAR Hlp,Hlp1: STRING[10];
    D,M,Y,H,Min,S: BYTE;
BEGIN
  decode_ixtime(Zeit,D,M,Y,H,Min,S);

  STR(H,Hlp);
  IF LENGTH(Hlp)=1 THEN Hlp := ' ' + Hlp;
  STR(Min,Hlp1);
  IF LENGTH(Hlp1)=1 THEN Hlp1 := '0' + Hlp1;
  MakeStrZeit := ' ' + Hlp + ':' + Hlp1;
END;


PROCEDURE List(ch: BYTE);
VAR tmp: pConvUserChan;
    b,i: BYTE;
    ChanTmp: pChanRec;
    Chan: INTEGER;
    S,Hlp: STRING;
    Flags: STRING[15];
    _Secret: BOOLEAN;           {Kanal ist geheim}
    _Invisible: BOOLEAN;        {Kanal ist unsichtbar}
    {$IFDEF CONVNETZ}
    tmp2: pExtUser;
    {$ENDIF}
BEGIN
  {Infos ber ALLE Kanle anzeigen}
  ChanTmp := ChannelDatRoot;

  {berschrift}
  SendString(ch,'Channel Flags  Topic'+#13);
  SendString(ch,'        Users'+#13);

  WHILE (ChanTmp<>NIL) DO BEGIN
    {Flags in einen String schreiben}
    Flags := '';
    _invisible := FALSE;
    _secret := FALSE;
    IF ChanTmp^.Flags AND TOPIC_CHOP>0 THEN Flags := Flags + 'T';
    IF ChanTmp^.Flags AND SECRET>0 THEN BEGIN
      Flags := Flags + 'S';
      _invisible := TRUE;
      _secret := TRUE;
    END;
    IF ChanTmp^.Flags AND PRIVAT>0 THEN Flags := Flags + 'P';
    IF ChanTmp^.Flags AND INVISIBLE>0 THEN BEGIN
      Flags := Flags + 'I';
      _invisible := TRUE;
    END;
    IF ChanTmp^.Flags AND MODERATE>0 THEN Flags := Flags + 'M';
    IF ChanTmp^.Flags AND LOCAL>0 THEN Flags := Flags + 'L';

    IF NOT _invisible OR (_invisible AND IsEingeloggt(ch,ChanTmp^.Channel)) THEN BEGIN
      IF (ChanTmp^.Flags>0) OR (LENGTH(ChanTmp^.Topic)>0) THEN BEGIN

        {Flags+Topic ausgeben}
        IF _secret THEN S := '------- '   {Kanal ist geheim}
        ELSE BEGIN
          STR(ChanTmp^.Channel,S);
          FOR i := 0 TO 6 DO IF LENGTH(S)=i THEN S := ' ' + S;
          S := S + ' ';
        END;

        FOR i := 0 TO 5 DO IF LENGTH(Flags)=i THEN Flags := Flags + ' ';

        S := S + Flags;
        SendString(ch,S+' '+ChanTmp^.Topic+#13);

        SendString(ch,StringD(' ',7));
      END
      ELSE BEGIN
        {Keine Flags vorhanden - einfach nur die User senden}
        STR(ChanTmp^.Channel,S);
        FOR i := 0 TO 6 DO IF LENGTH(S)=i THEN S := ' ' + S;
        SendString(ch,S);
      END;
      FOR b := 0 TO 255 DO IF KS[b]<> NIL THEN IF KS[b]^.status=6 THEN BEGIN
        tmp := KS[b]^.ConvData^.Channels;
        WHILE (tmp<>NIL) DO BEGIN
          IF tmp^.Channel=ChanTmp^.Channel THEN BEGIN
            S := '';
            IF (tmp^.Flags AND 1>0) OR KS[b]^.ConvData^.OperatorFlag OR KS[b]^.ConvData^.Away THEN BEGIN
              S := '(';
              IF KS[b]^.ConvData^.OperatorFlag THEN S := S + '!'
                                           ELSE IF tmp^.Flags AND 1>0 THEN S := S + '@';
              IF KS[b]^.ConvData^.Away THEN S := S + 'G';
              S := S + ')';
            END;
            SendString(ch,' ' + KS[b]^.ConvData^.Call + S);
          END;
          tmp := tmp^.next;
        END;
      END;
      {$IFDEF CONVNETZ}
      {Externe User}
      tmp2 := ExtUserRoot;
      WHILE tmp2<>NIL DO BEGIN
        IF tmp2^.Channel=ChanTmp^.Channel THEN BEGIN
          S := '';
          IF tmp2^.ChanOp OR tmp2^.OperatorFlag OR tmp2^.Away THEN BEGIN
            S := '(';
            IF tmp2^.OperatorFlag THEN S := S + '!'
                              ELSE IF tmp2^.ChanOp THEN S := S + '@';
            IF tmp2^.Away THEN S := S + 'G';
            S := S + ')';
          END;
          SendString(ch,' ' + tmp2^.Call + S);
        END;
        tmp2 := tmp2^.next;
      END;
      {$ENDIF}
      SendString(ch,#13);
    END;
    ChanTmp := ChanTmp^.Next;
  END;

  SendString(ch,'***'+#13);
END;


FUNCTION MakeIdleText(Diff: LONGINT): STRING;
VAR Hlp: STRING;
    rest,sec,min,hour,days: LONGINT;
    i: BYTE;
BEGIN
  rest := Diff;

  sec := rest MOD 60;
  rest := rest DIV 60;
  min := rest MOD 60;
  rest := rest DIV 60;
  hour := rest MOD 60;
  rest := rest DIV 60;
  days := rest;

  IF days>0 THEN BEGIN
    STR(days,Hlp);
    Hlp := Hlp + 'd';
  END
  ELSE IF hour>0 THEN BEGIN
         STR(hour,Hlp);
         Hlp := Hlp + 'h';
       END
       ELSE IF min>0 THEN BEGIN
              STR(min,Hlp);
              Hlp := Hlp + 'm';
            END
            ELSE BEGIN
              STR(sec,Hlp);
              Hlp := Hlp + 's';
            END;

  FOR i := 0 TO 5 DO IF LENGTH(Hlp) = i THEN Hlp := ' ' + Hlp;

  MakeIdleText := Hlp;
END;


PROCEDURE Who(ch: BYTE; S: STRING);
VAR tmp: pConvUserChan;
    b,i: BYTE;
    ChanTmp: pChanRec;
    Chan: INTEGER;
    Hlp: STRING;
    Found: BOOLEAN;
    Now: LONGINT;
    {$IFDEF CONVNETZ}
    tmp2: pExtUser;
    {$ENDIF}
BEGIN
  S := Gross(OnlyOneSpace(S));
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  Chan := -1;
  IF S='' THEN Chan := -1;
  IF POS('*',S)>0 THEN Chan := KS[ch]^.ConvData^.AktChan;

  {Stationen mit Away-Text anzeigen}
  IF POS('A',S)>0 THEN BEGIN

    {Infos ber ALLE Kanle anzeigen}
    ChanTmp := ChannelDatRoot;

    {berschrift}
    SendString(ch,'User    Host   Via    Chan.  Login'+#13);

    WHILE (ChanTmp<>NIL) DO BEGIN
      FOR b := 0 TO 255 DO IF KS[b]<> NIL THEN IF KS[b]^.status=6 THEN BEGIN
        tmp := KS[b]^.ConvData^.Channels;
        WHILE (tmp<>NIL) DO BEGIN
          IF (tmp^.Channel=ChanTmp^.Channel) AND KS[b]^.ConvData^.Away THEN BEGIN
            S := KS[b]^.ConvData^.Call;
            FOR i := 0 TO 5 DO IF LENGTH(S)=i THEN S := S + ' ';
            IF KS[b]^.ConvData^.OperatorFlag THEN S := S + '!'
                                         ELSE IF tmp^.Flags AND 1>0 THEN S := S + '@'
                                                                    ELSE S := S + ' ';
            Hlp := COPY(KS[b]^.ConvData^.Host,1,6);
            FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
            S := S + ' ' + Hlp;
            Hlp := COPY(KS[b]^.ConvData^.Via_Host,1,6);
            FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
            S := S + ' ' + Hlp;

            STR(tmp^.Channel,Hlp);
            FOR i := 0 TO 4 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;

            WITH KS[b]^.ConvData^ DO
            S := S + ' ' + Hlp + ' ' + MakeStrZeit(tmp^.Login) + ' ' + AwayText+' (since'+MakeStrZeit(AwaySince)+')';

            SendString(ch,S+' '+#13);
          END;
          tmp := tmp^.next;
        END;
      END;
      {$IFDEF CONVNETZ}
      {Externe user}
      tmp2 := ExtUserRoot;
      WHILE tmp2<>NIL DO BEGIN
        IF (tmp2^.Channel = ChanTmp^.Channel) AND tmp2^.Away THEN BEGIN
          S := tmp2^.Call;
          FOR i := 0 TO 5 DO IF LENGTH(S)=i THEN S := S + ' ';
          IF tmp2^.OperatorFlag THEN S := S + '!'
                            ELSE IF tmp2^.ChanOp THEN S := S + '@'
                                                 ELSE S := S + ' ';
          Hlp := COPY(tmp2^.Host,1,6);
          FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
          S := S + ' ' + Hlp;
          Hlp := COPY(tmp2^.Via_Host,1,6);
          FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
          S := S + ' ' + Hlp;

          STR(tmp2^.Channel,Hlp);
          FOR i := 0 TO 4 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;

          S := S + ' ' + Hlp + ' ' + MakeStrZeit(tmp2^.Login) + ' ' +
                 tmp2^.AwayText+' (since'+MakeStrZeit(tmp2^.AwaySince)+')';

          SendString(ch,S+' '+#13);
        END;

        tmp2 := tmp2^.next;
      END;
      {$ENDIF}
      ChanTmp := ChanTmp^.Next;
    END;

    SendString(ch,'***'+#13);
    Exit;
  END;


  IF POS('L',S)>0 THEN BEGIN
    {Infos ber ALLE Kanle anzeigen}
    ChanTmp := ChannelDatRoot;

    {berschrift}
    SendString(ch,'User    Host   Via    Chan.  Login RX      TX'+#13);

    WHILE (ChanTmp<>NIL) DO BEGIN
      FOR b := 0 TO 255 DO IF KS[b]<> NIL THEN IF KS[b]^.status=6 THEN BEGIN
        tmp := KS[b]^.ConvData^.Channels;
        WHILE (tmp<>NIL) DO BEGIN
          IF tmp^.Channel=ChanTmp^.Channel THEN BEGIN
            S := KS[b]^.ConvData^.Call;
            FOR i := 0 TO 5 DO IF LENGTH(S)=i THEN S := S + ' ';
            IF KS[b]^.ConvData^.OperatorFlag THEN S := S + '!'
                                         ELSE IF tmp^.Flags AND 1>0 THEN S := S + '@'
                                                                    ELSE S := S + ' ';
            Hlp := COPY(KS[b]^.ConvData^.Host,1,6);
            FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
            S := S + ' ' + Hlp;
            Hlp := COPY(KS[b]^.ConvData^.Via_Host,1,6);
            FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
            S := S + ' ' + Hlp;

            {Kanal geheim?}
            IF ChanTmp^.Flags AND SECRET>0 THEN Hlp := '-----'
            ELSE BEGIN
              STR(tmp^.Channel,Hlp);
              FOR i := 0 TO 4 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
            END;

            S := S + ' ' + Hlp + ' ' + MakeStrZeit(tmp^.Login) + ' ';
            STR(KS[b]^.ConvData^.RX_Bytes,Hlp);
            FOR i := 0 TO 6 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
            S := S + Hlp + ' ';
            STR(KS[b]^.ConvData^.TX_Bytes,Hlp);
            FOR i := 0 TO 6 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
            S := S + Hlp;
            SendString(ch,S+' '+#13);

            IF LENGTH(KS[b]^.ConvData^.Pers)>0 THEN SendString(ch,StringD(' ',8)+'Personal: '+KS[b]^.ConvData^.Pers+#13);
            SendString(ch,StringD(' ',8)+'Last Activity: '+MakeStrZeit(KS[b]^.ConvData^.LastText)+#13);
          END;
          tmp := tmp^.next;
        END;
      END;
      {$IFDEF CONVNETZ}
      {Externe User}
      tmp2 := ExtUserRoot;
      WHILE tmp2<>NIL DO BEGIN
        IF tmp2^.Channel=ChanTmp^.Channel THEN BEGIN
          S := tmp2^.Call;
          FOR i := 0 TO 5 DO IF LENGTH(S)=i THEN S := S + ' ';
          IF tmp2^.OperatorFlag THEN S := S + '!'
                            ELSE IF tmp2^.ChanOp THEN S := S + '@'
                                                 ELSE S := S + ' ';
          Hlp := COPY(tmp2^.Host,1,6);
          FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
          S := S + ' ' + Hlp;
          Hlp := COPY(tmp2^.Via_Host,1,6);
          FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
          S := S + ' ' + Hlp;

          {Kanal geheim?}
          IF ChanTmp^.Flags AND SECRET>0 THEN Hlp := '-----'
          ELSE BEGIN
            STR(tmp^.Channel,Hlp);
            FOR i := 0 TO 4 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
          END;

          S := S + ' ' + Hlp + ' ' + MakeStrZeit(tmp2^.Login) + ' ';
          Hlp := '      0       0';
          S := S + Hlp;
          SendString(ch,S+' '+#13);

          IF LENGTH(tmp2^.Pers)>0 THEN SendString(ch,StringD(' ',8)+'Personal: '+tmp2^.Pers+#13);
          SendString(ch,StringD(' ',8)+'Last Activity: '+MakeStrZeit(tmp2^.LastText)+#13);
        END;

        tmp2 := tmp2^.next;
      END;
      {$ENDIF}

      ChanTmp := ChanTmp^.Next;
    END;

    SendString(ch,'***'+#13);
    Exit;  END;


  IF Chan=-1 THEN BEGIN
    {Infos ber ALLE Kanle anzeigen}
    ChanTmp := ChannelDatRoot;

    {berschrift}
    SendString(ch,'User    Host   Via    Chan.  Login Personal'+#13);

    WHILE (ChanTmp<>NIL) DO BEGIN
      FOR b := 0 TO 255 DO IF KS[b]<> NIL THEN IF KS[b]^.status=6 THEN BEGIN
        tmp := KS[b]^.ConvData^.Channels;
        WHILE (tmp<>NIL) DO BEGIN
          IF tmp^.Channel=ChanTmp^.Channel THEN BEGIN
            S := KS[b]^.ConvData^.Call;
            FOR i := 0 TO 5 DO IF LENGTH(S)=i THEN S := S + ' ';
            IF KS[b]^.ConvData^.OperatorFlag THEN S := S + '!'
                                         ELSE IF tmp^.Flags AND 1>0 THEN S := S + '@'
                                                                    ELSE S := S + ' ';
            Hlp := COPY(KS[b]^.ConvData^.Host,1,6);
            FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
            S := S + ' ' + Hlp;
            Hlp := COPY(KS[b]^.ConvData^.Via_Host,1,6);
            FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
            S := S + ' ' + Hlp;

            {Kanal geheim?}
            IF ChanTmp^.Flags AND SECRET>0 THEN Hlp := '-----'
            ELSE BEGIN
              STR(tmp^.Channel,Hlp);
              FOR i := 0 TO 4 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
            END;

            S := S + ' ' + Hlp + ' ' + MakeStrZeit(tmp^.Login) + ' ' + KS[b]^.ConvData^.Pers;
            IF KS[b]^.ConvData^.Away THEN S := S + ' (AWAY)';

            SendString(ch,S+' '+#13);
          END;
          tmp := tmp^.next;
        END;
      END;
      {$IFDEF CONVNETZ}
      {Externe user}
      tmp2 := ExtUserRoot;
      WHILE tmp2<>NIL DO BEGIN
        IF tmp2^.Channel=ChanTmp^.Channel THEN BEGIN
          S := tmp2^.Call;
          FOR i := 0 TO 5 DO IF LENGTH(S)=i THEN S := S + ' ';
          IF tmp2^.OperatorFlag THEN S := S + '!'
                            ELSE IF tmp2^.ChanOp THEN S := S + '@'
                                                 ELSE S := S + ' ';
          Hlp := COPY(tmp2^.Host,1,6);
          FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
          S := S + ' ' + Hlp;
          Hlp := COPY(tmp2^.Via_Host,1,6);
          FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
          S := S + ' ' + Hlp;

          {Kanal geheim?}
          IF ChanTmp^.Flags AND SECRET>0 THEN Hlp := '-----'
          ELSE BEGIN
            STR(tmp2^.Channel,Hlp);
            FOR i := 0 TO 4 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
          END;

          S := S + ' ' + Hlp + ' ' + MakeStrZeit(tmp2 ^.Login) + ' ' + tmp2^.Pers;
          IF tmp2^.Away THEN S := S + ' (AWAY)';

          SendString(ch,S+' '+#13);
        END;
        tmp2 := tmp2^.next;
      END;
      {$ENDIF}

      ChanTmp := ChanTmp^.Next;
    END;

    SendString(ch,'***'+#13);
    Exit;
  END;

  IF Chan>-1 THEN BEGIN
    Now := AktUnixTime;
    SendString(ch,'User    Host   Via    Chan.   Idle Personal'+#13);

    FOR b := 0 TO 255 DO IF KS[b]<> NIL THEN IF KS[b]^.status=6 THEN BEGIN
      tmp := KS[b]^.ConvData^.Channels;
      WHILE (tmp<>NIL) DO BEGIN
        IF tmp^.Channel=Chan THEN BEGIN
          S := KS[b]^.ConvData^.Call;
          FOR i := 0 TO 5 DO IF LENGTH(S)=i THEN S := S + ' ';

          {Flags}
          IF KS[b]^.ConvData^.OperatorFlag THEN S := S + '!'
                                       ELSE IF tmp^.Flags AND IS_CHANOP>0 THEN S := S + '@'
                                                                          ELSE S := S + ' ';

          Hlp := COPY(KS[b]^.ConvData^.Host,1,6);
          FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
          S := S + ' ' + Hlp;
          Hlp := COPY(KS[b]^.ConvData^.Via_Host,1,6);
          FOR i := 0 TO 5 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';
          S := S + ' ' + Hlp + ' ';

          STR(tmp^.Channel,Hlp);
          FOR i := 0 TO 4 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
          S := S + Hlp + ' ' + MakeIdleText(Now - KS[b]^.ConvData^.LastText)+' '+KS[b]^.ConvData^.Pers;

          IF KS[b]^.ConvData^.Away THEN S := S + ' (AWAY)';

          SendString(ch,S+#13);
        END;

        tmp := tmp^.next;
      END;
    END;

    SendString(ch,'***'+#13);

  END;

END;


{Topic setzen}
PROCEDURE SetTopic(Chan: INTEGER; Call: str6; Host: str15; S: STRING);
VAR tmp: pChanRec;
    Found: BOOLEAN;
BEGIN
  tmp := ChannelDatRoot;
  Found := FALSE;

  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Channel=Chan THEN BEGIN
      Found := TRUE;
      tmp^.Topic := S;
      tmp^.topic_who := Call;
      tmp^.topic_who_Host := Host;
      tmp^.Topic_When := AktUnixTime;
    END
    ELSE tmp := tmp^.Next;
  END;

  {$IFDEF CONVNETZ}
  IF Found THEN Host_TOPI_Cmd(0,Call,Host,tmp^.Topic_When,Chan,S);
  {$ENDIF}

END;


{Personal-Text fr Call setzen}
PROCEDURE SetPersonalText(Call: str6; Text: str127);
VAR F: FILE OF tConvUserDataFile;
    DS: tConvUserDataFile;
    Found: BOOLEAN;
BEGIN
   {$IFNDEF FPK}
  ASSIGN(f,QRVPath+'CONVUSER.MCT');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    REWRITE(f);
    DS.Call := UserFileVers;
    DS.Pers := '';
    WRITE(f,DS);

    DS.Call := Call;
    DS.Pers := Text;
    DS.Bell := FALSE;
    DS.Spalten := 78;
    WRITE(f,DS);
    CLOSE(f);
    Exit;
  END;

  Found := FALSE;
  WHILE NOT EOF(f) AND NOT Found DO BEGIN
    READ(f,DS);
    IF DS.Call=Call THEN BEGIN
      SEEK(f,FILEPOS(f)-1);
      DS.Pers := Text;
      WRITE(f,DS);
      Found := TRUE;
    END;
  END;

  IF NOT Found THEN BEGIN
    SEEK(f,FILESIZE(f));
    DS.Call := Call;
    DS.Pers := Text;
    DS.Bell := FALSE;
    DS.Spalten := 78;
    WRITE(f,DS);
  END;
  CLOSE(f);
   {$ENDIF}
END;



PROCEDURE Personal(ch: BYTE; S: STRING);
BEGIN
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  IF S='' THEN BEGIN
    SetPersonalText(KS[ch]^.ConvData^.Call,'');
    KS[ch]^.ConvData^.Pers := '';
    S := '*** ('+ConvTime+') '+KS[ch]^.ConvData^.Call+'@'+KS[ch]^.ConvData^.Host+' removed personal text.'+#13;
    SendChannelMessage(FALSE,KS[ch]^.ConvData^.AktChan,S,ch);
    SendString(ch,'*** ('+ConvTime+') Personal text deleted.'+#13);
    Exit;
  END;
  SetPersonalText(KS[ch]^.ConvData^.Call,S);
  KS[ch]^.ConvData^.Pers := S;

  S := '*** ('+ConvTime+') '+KS[ch]^.ConvData^.Call+'@'+KS[ch]^.ConvData^.Host+' set personal text:'+#13+
       '    '+S+#13;
  SendChannelMessage(FALSE,KS[ch]^.ConvData^.AktChan,S,ch);
  SendString(ch,'*** ('+ConvTime+') Personal text set.'+#13);

END;



PROCEDURE PutChannelFlags(Chan: INTEGER; Flags: WORD);
VAR tmp: pChanRec;
    Found: BOOLEAN;
BEGIN
  tmp := ChannelDatRoot;
  Found := FALSE;

  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Channel=Chan THEN BEGIN
      Found := TRUE;
      tmp^.Flags := Flags;
    END;
    tmp := tmp^.Next;
  END;
END;




FUNCTION GetUserFlags(Chan: INTEGER; ch: BYTE): WORD;
VAR tmp: pConvUserChan;
    Found: BOOLEAN;
BEGIN
  Found := FALSE;
  tmp := KS[ch]^.ConvData^.Channels;

  GetUserFlags := 0;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Channel=Chan THEN BEGIN
      GetUserFlags := tmp^.Flags;
      Found := TRUE;
    END;
    tmp := tmp^.next;
  END;
END;


PROCEDURE MakeChannelOp(DestCall,FromCall,FromHost: STRING10; Chan: INTEGER;From: BYTE);
VAR tmp: pConvUserChan;
    b: BYTE;
    S: STRING;
BEGIN
  STR(Chan,S);
  S := '*** ('+Convtime+') '+FromCall+'@'+FromHost+' makes you a channel-OperatorFlag for channel '+S+'.';
  FOR b := 0 TO 255 DO IF KS[b]<>NIL THEN IF KS[b]^.status=6 THEN BEGIN
    IF (KS[b]^.ConvData^.Call=DestCall) AND (From<>b) THEN BEGIN
      tmp := KS[b]^.ConvData^.Channels;
      WHILE tmp<>NIL DO BEGIN
        IF tmp^.Channel=Chan THEN BEGIN
          tmp^.Flags := tmp^.Flags OR IS_CHANOP;
          SendString(b,S+#13);
          SendString(From,'*** ('+Convtime+') You made '+KS[b]^.ConvData^.Call+' an OperatorFlag.'+#13);
        END;
        tmp := tmp^.next;
      END;
    END;
  END;
  {$IFDEF CONVNETZ}
  Host_OPER_Cmd(0,fromCall,Chan,DestCall);
  {$ENDIF}
END;




PROCEDURE Topic(ch: BYTE; S: STRING);
VAR b: BYTE;
    UserFlags,ChanFlags: WORD;
BEGIN
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  ChanFlags := GetChannelFlags(KS[ch]^.ConvData^.AktChan);
  UserFlags := GetUserFlags(KS[ch]^.ConvData^.AktChan,ch);
    {Channel-Op}             {OperatorFlag}                {Topic}
  IF (UserFlags AND 1=0) AND (UserFlags AND 2=0) AND (ChanFlags AND 2>0) THEN BEGIN
    SendString(ch,'*** ('+ConvTime+') You must be a channel-OperatorFlag to change the topic.'+#13);
    Exit;
  END;


  IF S='' THEN BEGIN
    {Convers lschen}
    SetTopic(KS[ch]^.ConvData^.AktChan,KS[ch]^.ConvData^.Call,KS[ch]^.ConvData^.Host,'');
    S :='*** ('+ConvTime+') '+KS[ch]^.ConvData^.Call+'@'+KS[ch]^.ConvData^.Host+' removed channel topic.';
    SendChannelMessage(FALSE,KS[ch]^.ConvData^.AktChan,S+#13,ch);
    SendString(ch,'*** ('+ConvTime+') Removed channel topic.'+#13);
    Exit;
  END;
  SetTopic(KS[ch]^.ConvData^.AktChan,KS[ch]^.ConvData^.Call,KS[ch]^.ConvData^.Host,S);

  S :='*** ('+ConvTime+') '+KS[ch]^.ConvData^.Call+'@'+KS[ch]^.ConvData^.Host+' set channel topic:'+#13+'    '+S;
  SendChannelMessage(FALSE,KS[ch]^.ConvData^.AktChan,S+#13,ch);
  SendString(ch,'*** ('+ConvTime+') Channel topic set.'+#13);
END;


PROCEDURE Mode(ch: BYTE; S: STRING);
VAR Flags: WORD;
    i,Ende: BYTE;
    OK,Dir: BOOLEAN;
    Hlp: STRING;
    OldFlags: WORD;
BEGIN
  IF POS(' ',S)>0 THEN S := Gross(COPY(S,POS(' ',S)+1,255))
                  ELSE S := '';

  Flags := GetUserFlags(KS[ch]^.ConvData^.AktChan,ch);
  OldFlags := Flags;
  IF (Flags AND 1=0) AND (Flags AND 2=0) THEN BEGIN
    SendString(ch,'*** You are not an OperatorFlag!'+#13);
    Exit;
  END;

  {Kanal-Flags auslesen}
  Flags := GetChannelFlags(KS[ch]^.ConvData^.AktChan);
  OK := FALSE;
  IF LENGTH(S)>0 THEN BEGIN
    IF KS[ch]^.ConvData^.AktChan=0 THEN SendString(ch,'*** non modes on channel 0!'+#13)
    ELSE BEGIN
      FOR i := 1 TO LENGTH(S) DO BEGIN
        CASE S[i] OF
          '+': BEGIN
                 OK := TRUE;
                 Dir := TRUE;
               END;
          '-': BEGIN
                 OK := TRUE;
                 Dir := FALSE;
               END;
          'T': IF OK THEN IF Dir THEN Flags := Flags OR TOPIC_CHOP
                                 ELSE Flags := Flags AND 65535-TOPIC_CHOP;
          'I': IF OK THEN IF Dir THEN Flags := Flags OR INVISIBLE
                                 ELSE Flags := Flags AND 65535-INVISIBLE;
          'S': IF OK THEN IF Dir THEN Flags := Flags OR SECRET
                                 ELSE Flags := Flags AND 65535-SECRET;
          'M': IF OK THEN IF Dir THEN Flags := Flags OR MODERATE
                                 ELSE Flags := Flags AND 65535-MODERATE;
          'P': IF OK THEN IF Dir THEN Flags := Flags OR PRIVAT
                                 ELSE Flags := Flags AND 65535-PRIVAT;
          'L': IF OK THEN IF Dir THEN Flags := Flags OR LOCAL
                                 ELSE Flags := Flags AND 65535-LOCAL;
          'O': IF OK THEN BEGIN
                 Hlp := COPY(S,i+1,255);
                 Ende := LENGTH(Hlp);
                 IF POS('+',Hlp)>0 THEN IF POS('+',Hlp)<Ende THEN Ende := POS('+',Hlp);
                 IF POS('-',Hlp)>0 THEN IF POS('-',Hlp)<Ende THEN Ende := POS('-',Hlp);
                 Hlp := LTRIM(RTRIM(COPY(Hlp,1,Ende)));
                 MakeChannelOp(Klein(Hlp),KS[ch]^.ConvData^.Call,KS[ch]^.ConvData^.Host,KS[ch]^.ConvData^.AktChan,ch);
               END;
        END;
      END;
      PutChannelFlags(KS[ch]^.ConvData^.AktChan,Flags);
    END;
  END;

  S := '*** Flags: ';
  FOR i := 1 TO 16 DO
    IF Flags AND (Hoch(2,i))>0 THEN BEGIN
      CASE i OF
        1: S := S + 'T';
        2: S := S + 'I';
        3: S := S + 'S';
        4: S := S + 'M';
        5: S := S + 'P';
        6: S := S + 'L';
      END;
    END;
  SendString(ch,S+#13);
  {$IFDEF CONVNETZ}
  IF Flags<>OldFlags THEN Host_MODE_Cmd(0,KS[ch]^.ConvData^.AktChan,Flags);
  {$ENDIF}
END;


PROCEDURE Quit(ch: BYTE);
VAR tmp: pConvUserChan;
BEGIN
  tmp := KS[ch]^.ConvData^.Channels;

  WHILE (tmp<>NIL) DO BEGIN
    BenachrichtigeChannelUser_Disconnect(ch,tmp^.Channel,'/quit');
    DelOneUserAtChannel(tmp^.Channel);

    tmp := tmp^.next;
  END;

  WHILE KS[ch]^.ConvData^.Channels<>NIL DO BEGIN
    tmp := KS[ch]^.ConvData^.Channels^.Next;
    dispose(KS[ch]^.ConvData^.Channels);
    KS[ch]^.ConvData^.Channels := tmp;
  END;

  IF KS[ch]^.laststatus=0 THEN
               KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ
           ELSE SendString(ch,'Convers-Session terminated'+#13);
  KS[ch]^.status := KS[ch]^.ConvData^.LastStatus;
  dispose(KS[ch]^.ConvData);
  KS[ch]^.ConvData := NIL;
END;


PROCEDURE MSG(ch: BYTE; S: STRING);
VAR Chan: INTEGER;
    Hlp,Text: STRING;
    code: WORD;
    OK: BOOLEAN;
BEGIN
  S := LTRIM(RTRIM(OnlyOneSpace(S)));
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  IF POS(' ',S)>0 THEN BEGIN
    IF COPY(S,1,1)='#' THEN Hlp := Klein(COPY(S,2,POS(' ',S)-2))
                       ELSE Hlp := Klein(COPY(S,1,POS(' ',S)-1));
    Text := COPY(S,POS(' ',S)+1,255);
  END
  ELSE BEGIN
    IF COPY(S,1,1)='#' THEN Hlp := Klein(COPY(S,2,255))
                       ELSE Hlp := Klein(S);
    Text := '';
  END;

  IF COPY(S,1,1)='#' THEN BEGIN
    {Nachricht an einen anderen Kanal schreiben}
    VAL(Hlp,Chan,code);
    IF code<>0 THEN BEGIN
      SendString(ch,'*** Wrong channel number.'+#13);
      Exit;
    END;
    IF IsEingeloggt(ch,Chan) THEN SendTextToChannelUser(Chan,Text,KS[ch]^.ConvData^.Call,ch)
                             ELSE SendString(ch,'*** ('+ConvTime+') You have not joined channel '+Hlp+'.'+#13);
    Exit;
  END;

  OK := SendTextToUser(Hlp,Text,ch);
  IF NOT OK THEN SendString(ch,'*** ('+ConvTime+') No such user: '+Hlp+'.'+#13);

END;


PROCEDURE Help(ch: BYTE);
BEGIN
  SendString(ch,'Kommandos knnen abgekrzt werden. Kommandos:'+#13);
  SendString(ch,'/Away [Text]            markiert Dich als abwesend'+#13);
  SendString(ch,'/Channel n              wechselt auf Kanal n'+#13);
  SendString(ch,'/Invite User            ldt User auf Deinen Kanal ein'+#13);
  SendString(ch,'/LISt                   listet alle Kanle und ihre Themen'+#13);
  SendString(ch,'/LEave [Kanal]          verlt Kanal oder derzeitigen Kanal'+#13);
  SendString(ch,'/Msg User|#Kanal Text   sendet Text an User oder verbundenen Kanal'+#13);
  SendString(ch,'/ME Text                sendet einen Aktionstext'+#13);
  SendString(ch,'/MOde [Kanal] Optionen  setzt Kanaloptionen'+#13);
  SendString(ch,'/Personal [Text]        setzt persnliche Beschreibung'+#13);
  SendString(ch,'/Quit                   convers verlassen'+#13);
  SendString(ch,'/Topic [#Kanal] [Text]  setzt Thema des Kanals. Thema=@ entfernt Thema'+#13);
  SendString(ch,'/UPtime                 wielange luft dieses conversd berhaupt schon ?'+#13);
  SendString(ch,'/Verbose                Laber-Modus an/aus'+#13);
  SendString(ch,'/VERSion                zeigt Info zu dieser Version'+#13);
  SendString(ch,'/Who [*|A|L]            zeigt User und Ihre Kanle (eigner|abwesend|lang)'+#13);
  SendString(ch,'***'+#13);
END;


PROCEDURE Invite(ch: BYTE; S: STRING);
VAR tmp: pConvUserChan;
    b: BYTE;
    Whole,Found,LoggedIn: BOOLEAN;
    Hlp: STRING;
    Host: STRING[15];
    {$IFDEF CONVNETZ}
    tmp2: pExtUser;
    {$ENDIF}
BEGIN

  S := Klein(LTRIM(RTRIM(OnlyOneSpace(S))));
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  IF S='' THEN BEGIN
    SendString(ch,'*** need username'+#13);
    Exit;
  END;

  STR(KS[ch]^.ConvData^.AktChan,Hlp);

  Whole := FALSE;
  FOR b := 0 TO 255 DO IF KS[b]<>NIL THEN IF KS[b]^.status=6 THEN IF (ch<>b) THEN BEGIN
    IF KS[b]^.ConvData^.Call=S THEN BEGIN
      tmp := KS[b]^.ConvData^.Channels;
      Found := FALSE;
      WHILE (tmp<>NIL) AND NOT Found DO BEGIN
        Found := TRUE;
        Whole := TRUE;
        IF tmp^.Channel=KS[ch]^.ConvData^.AktChan THEN BEGIN
          SendString(ch,'*** ('+ConvTime+') User '+S+' is allready on this channel.'+#13);
          Exit;
        END;
      END;
      IF Found THEN BEGIN
        SendString(b,#7#7+'*** ('+ConvTime+') Message from '+KS[ch]^.ConvData^.Call+'...'+#13);
        SendString(b,'Please join channel '+Hlp+#7#7#13);
        KS[b]^.ConvData^.LastInviChan := KS[ch]^.ConvData^.AktChan;
        Host := KS[b]^.ConvData^.Host;
        SendString(ch,'*** ('+ConvTime+') Invitation sent to '+S+' @ '+Host+'.'+#13);
      END;
    END;
  END;

  {$IFDEF CONVNETZ}
  IF NOT Whole THEN BEGIN
    Found := FALSE;
    LoggedIn := FALSE;

    tmp2 := ExtUserRoot;
    WHILE (tmp2<>NIL) DO BEGIN
      IF tmp2^.Call=S THEN BEGIN
        Found := TRUE;
        Host := tmp2^.Host;
        IF tmp2^.Channel=KS[ch]^.Convdata^.AktChan THEN LoggedIn := TRUE;
      END;
      tmp2 := tmp2^.next;
    END;

    IF Found THEN BEGIN
      IF LoggedIn THEN  SendString(ch,'*** ('+ConvTime+') User '+S+' is allready on this channel.'+#13)
      ELSE BEGIN
        Host_INVI_Cmd(0,KS[ch]^.ConvData^.Call,S,KS[ch]^.ConvData^.AktChan);
        SendString(ch,'*** ('+ConvTime+') Invitation sent to '+S+' @ '+Host+'.'+#13);
      END;
      Exit;
    END;
  END;
  {$ENDIF}
  SendString(ch,'*** ('+ConvTime+') User '+S+' was not connected.'+#13);
END;


PROCEDURE Verbose(ch: BYTE);
BEGIN
  WITH KS[ch]^.ConvData^ DO BEGIN
    Verb := NOT Verb;
    IF Verb THEN SendString(ch,'*** Verbose mode enabled'+#13)
            ELSE SendString(ch,'*** Verbose mode disabled'+#13);
  END;
END;


PROCEDURE Away(ch: BYTE; S: STRING);
BEGIN
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  IF (S='') AND NOT KS[ch]^.ConvData^.Away THEN BEGIN
    SendString(ch,'*** ('+ConvTime+') Actually you are marked as being here :-)'+#13);
    Exit;
  END;

  KS[ch]^.ConvData^.AwayText := S;
  IF S='' THEN BEGIN
    KS[ch]^.ConvData^.Away := FALSE;
    KS[ch]^.ConvData^.AwaySince := AktUnixtime;
    SendString(ch,'*** ('+ConvTime+') You are no longer marked as being away.'+#13);
    WITH KS[ch]^.ConvData^ DO BEGIN
      S := '*** ('+Convtime+') '+ Call + '@' + Host + ' is back again.'+#13;
  {$IFDEF CONVNETZ}
      Host_AWAY_Cmd(0,Call,Host,AwaySince,'');
  {$ENDIF}
    END;
    SendChannelMessage(FALSE,KS[ch]^.ConvData^.AktChan,S,ch);
  END
  ELSE BEGIN
    KS[ch]^.ConvData^.Away := TRUE;
    KS[ch]^.ConvData^.AwaySince := AktUnixtime;
    SendString(ch,'*** ('+ConvTime+') You are marked as being away.'+#13);
    WITH KS[ch]^.ConvData^ DO BEGIN
  {$IFDEF CONVNETZ}
      Host_AWAY_Cmd(0,Call,Host,AwaySince,S);
  {$ENDIF}
      S := '*** ('+Convtime+') '+ Call + '@' + Host + ' has gone away:'+#13+'    '+S+#13;
    END;
    SendChannelMessage(FALSE,KS[ch]^.ConvData^.AktChan,S,ch);
  END;
END;


PROCEDURE Uptime(ch: BYTE);
BEGIN
  SendString(ch,'*** conversd@'+OwnConvData^.HostName+' is up for '+TimeLong(AktUnixTime-OwnConvData^.StartupTime)+'.'+#13);
END;


{$IFDEF CONVNETZ}
PROCEDURE Link(ch: BYTE; S: STRING);
VAR b,i: BYTE;
    Hlp: STRING;
    tmp: pHostListe;
    dummy: BOOLEAN;
BEGIN
  S := LTRIM(RTRIM(OnlyOneSpace(S)));
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';
  SendString(ch,'WARNING: network-support is VERY experimental and may cause pc-hangups'+#13);
  SendString(ch,'         and severe problems in an existing convers-network'+#13); 
  SendString(ch,'         You have been warn, I am not responsible for anything'+#13);
  IF S='' THEN BEGIN   {Liste der eingetragenen Links anzeigen}
    SendString(ch,'Host      State        Quality Revision  Since NextTry Tries Queue    RX    TX'+#13);

    tmp := HostDataRoot;
    WHILE tmp<>NIL DO BEGIN
      S := tmp^.HostName;
      FOR i := 0 TO 8 DO IF LENGTH(S)=i THEN S := S + ' ';

      {Abhngig vom Status die Informationen ausgeben}
      CASE tmp^.State OF
        0: BEGIN
             S := S + ' Disconnected   ---            '+MakeStrZeit(tmp^.Since)+' ';
             IF tmp^.Trusted THEN S := S + '(trusted host)'
             ELSE BEGIN
               STR(tmp^.Since+(tmp^.Tries*60*2),Hlp);
               FOR i := 0 TO 6 DO Hlp := ' ' + Hlp;
               S := S + Hlp + ' ';
               STR(tmp^.Tries,Hlp);
               FOR i := 0 TO 4 DO Hlp := ' ' + Hlp;
               S := S + Hlp;
             END;
           END;
        2: BEGIN
             S := S + ' Connected   ';
             IF tmp^.TX_Qual=0 THEN Hlp := ' ---'
                               ELSE Hlp := MakeIdleText(tmp^.TX_Qual);
             Hlp := LTRIM(Hlp);
             FOR i := 0 TO 3 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
             S := S + Hlp + '/';
             IF tmp^.RX_Qual=0 THEN BEGIN
               IF tmp^.TX_Qual>0 THEN Hlp := MakeIdleText(tmp^.TX_Qual)
                                 ELSE Hlp := '--- ';
             END
             ELSE Hlp := MakeIdleText(tmp^.RX_Qual);
             Hlp := LTRIM(Hlp);
             FOR i := 0 TO 3 DO IF LENGTH(Hlp)=i THEN Hlp := Hlp + ' ';

             S := S + Hlp;
             Hlp := Klein(tmp^.Revision);
             FOR i := 0 TO 7 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
             S := S + Hlp + ' ' + MakeStrZeit(tmp^.Since)+StringD(' ',15);
             STR(KS[tmp^.Chan]^.TxW,Hlp);
             FOR i := 0 TO 4 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
             S := S + Hlp + ' ';
             STR(Round(tmp^.RX_Bytes/1024),Hlp);
             FOR i := 0 TO 3 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
             S := S + Hlp + 'K' + ' ';
             STR(Round(tmp^.TX_Bytes/1024),Hlp);
             FOR i := 0 TO 3 DO IF LENGTH(Hlp)=i THEN Hlp := ' ' + Hlp;
             S := S + Hlp + 'K';
           END;
         END;
      SendString(ch,S+#13);
      tmp := tmp^.next;
    END;

    SendString(ch,'***'+#13);
    Exit;
  END;


  IF NOT KS[ch]^.ConvData^.OperatorFlag THEN BEGIN
    SendString(ch,'You must be an Operator to set up new links'+#13);
    Exit;
  END;

  IF S[1]='-' THEN BEGIN
    {*************** LINK LSCHEN ***************************************}
    S := LTRIM(RTRIM(COPY(S,2,255)));
    DelConvLink(S);
    SendString(ch,'*** ok'+#13);
    SaveConvLinksInFile;
    Exit;
  END;

  {****************** LINK DABEI ****************************************}
  IF POS(' ',S)>0 THEN BEGIN
    Hlp := COPY(S,POS(' ',S)+1,255);
    S := COPY(S,1,POS(' ',S)-1);
    dummy := FALSE;
  END
  ELSE BEGIN
    Hlp := '';
    dummy := TRUE;
  END;
  AddConvLink(S,dummy,Hlp);
  SendString(ch,'*** ok'+#13);
  SaveConvLinksInFile;

END;
{$ENDIF}


PROCEDURE ME(ch: BYTE; S: STRING);
BEGIN
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  S := '*** '+KS[ch]^.ConvData^.Call+'@'+KS[ch]^.ConvData^.Host+' '+S;
  SendChannelMessage(TRUE,KS[ch]^.ConvData^.AktChan,S+#13,ch);
  {$IFDEF CONVNETZ}
  Host_CMSG_Cmd(0,KS[ch]^.ConvData^.Call,KS[ch]^.ConvData^.AktChan,S);
  {$ENDIF}
END;

{$IFDEF CONVNETZ}
PROCEDURE dest(Ch:BYTE;S:STRING);
VAR tmp:pDesti;
    s2:STRING[80];
BEGIN
  tmp:=DestiRoot;
  S2:='';
  WHILE tmp<>NIL DO
  BEGIN
    s2:=s2+copy(tmp^.host,1,8)+' '+makeIdleText(tmp^.Zeit)+' ('+
        tmp^.revis+StringD(' ',8-length(tmp^.revis))+')';
    IF s[0]>#65 THEN
    BEGIN
      PutData(ch,s2+#13);
      s2:='';
    END;
    tmp:=tmp^.next;
  END;
  putData(ch,s2+#13+'***'+#13);
END;
{$ENDIF}


FUNCTION TestConvCmd(S: STRING): BYTE;
CONST AnzBef = 25;
      Bef : ARRAY[1..AnzBef] OF STRING[10] =
        ('AWAY','BEEP','CHANNEL','CHARSET','DESTINATIONS','EXCLUDE','HELP',
         'INVITE','LINKS','LIST','LEAVE','MSG','ME','MODE','NOTIFY',
         'PERSONAL','PROMPT','QUIT','QUERY','TOPIC','UPTIME','VERBOSE',
         'VERSION','WHO','WIDTH');
VAR i: INTEGER;
BEGIN
  DELETE(s,1,1);
  S := Gross(S);
  TestConvCmd := 0;
  FOR i := 1 TO AnzBef DO BEGIN
    IF COPY(Bef[i],1,LENGTH(S)) = S THEN BEGIN
      TestConvCmd := i;
      Exit;
    END;
  END;
END;


PROCEDURE ConvCommand(ch: BYTE; S: STRING);
VAR cmd: BYTE;
    OK: BOOLEAN;
BEGIN
  IF s[length(s)]=#13 THEN dec(byte(s[0]));
  IF POS(' ',S)>0 THEN cmd := TestConvCmd(COPY(S,1,POS(' ',S)-1))
                  ELSE cmd := TestConvCmd(S);

  CASE cmd OF
     0: SendString(ch,'*** Invalid Command'#13);
     1: Away(ch,S);
     3: Channel(ch,S);
    {$IFDEF CONVNETZ}
     5: Dest(ch,s);
    {$ENDIF}
     7: Help(ch);
     8: Invite(ch,S);
    {$IFDEF CONVNETZ}
     9: Link(ch,S);
    {$ENDIF}
    10: List(ch);
    11: Leave(ch,S);
    12: MSG(ch,S);
    13: ME(ch,S);
    14: Mode(ch,S);
    16: Personal(ch,S);
    18: Quit(ch);
    20: Topic(ch,S);
    21: Uptime(ch);
    22: Verbose(ch);
    23: Version(ch);
    24: Who(ch,S);
    ELSE SendString(ch,'*** Invalid Command'#13);
  END;

END;




{Haupt-Routine - von hier verzweigt alles}
PROCEDURE HandleConv(ch: BYTE; S: STRING);
{$IFDEF CONVNETZ}
VAR Hlp: STRING;
    tmp: WORD;
    OK: BOOLEAN;
    Text: STRING;
{$ENDIF}
BEGIN
  S := LTRIM(RTRIM(S));
  CASE KS[ch]^.status OF
       6: BEGIN
           inc(KS[ch]^.ConvData^.TX_Bytes,LENGTH(S));
           IF S[1]='/' THEN ConvCommand(ch,s)
           ELSE BEGIN
             KS[ch]^.ConvData^.LastText := AktUnixTime;
             IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
             IF KS[ch]^.ConvData^.Away THEN SendString(ch,'*** You are away, aren''t you? :-)'+#13);
             S := OnlyOneSpace(S);
             SendTextToChannelUser(KS[ch]^.ConvData^.AktChan,S,KS[ch]^.ConvData^.Call,ch);

           END;
         END;
{$IFDEF CONVNEU}
      101: BEGIN
             IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
             IF COPY(S,1,9)='/'#255#128'LOGIN ' THEN BEGIN
               S := COPY(S,10,255);
               HostLogin(ch,S);
             END;
             IF Gross(COPY(S,1,6))='/LOGIN' THEN BEGIN
               NEW(KS[ch]^.ConvData);

               KS[ch]^.ConvData^.LastStatus:=KS[ch]^.Laststatus;
               KS[ch]^.status:=6;

               WITH KS[ch]^.ConvData^ DO BEGIN
                 {Kanal, in den eingeloggt werden soll, 'rausfinden}
                 Text := LTRIM(RTRIM(COPY(S,7,255)));
                 VAL(Text,AktChan,tmp);
                 IF tmp <> 0 THEN AktChan := 0;

                 Channels := NIL;
                 Call := Klein(CutSSID(KS[ch]^.Call));
                 Host := Klein(OwnConvData^.HostName);
                 Via_Host := '';
                 Away := FALSE;
                 AwayText := '';
                 Verb := FALSE;
                 LastInviChan := 0;
                 RX_Bytes := 0;
                 TX_Bytes := 0;

                 S := 'conversd @ '+OwnConvData^.Hostname+' MCUT-'+WhatIsThis+' '+ConvRelease+' - Type /HELP for help.';
                 SendString(ch,S+#13);
                 Login2Channel(ch,AktChan);
               END;
             END;
           END;
{$ELSE}
  {$IFDEF CONVNETZ}
      101: BEGIN        {Login einer PingPong-Convers-Station (Host)}
             IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
             Text := S;
             IF S[1]='/' THEN DELETE(S,1,1);
             S := Gross(S);
             IF POS(' ',S)>0 THEN BEGIN
               Hlp := COPY(S,1,POS(' ',S)-1);
               S := COPY(S,POS(' ',S)+1,255);
             END
             ELSE BEGIN
               Hlp := S;
               S := '';
             END;

             IF COPY(Text,1,3)='/'+#255#128 THEN BEGIN
               OK := LoginToServer(ch,Text);
               IF OK THEN Exit;
             END;

             IF Hlp='LOGIN' THEN BEGIN
               NEW(KS[ch]^.ConvData);

               KS[ch]^.ConvData^.LastStatus:=KS[ch]^.Laststatus;
               KS[ch]^.status:=6;

               WITH KS[ch]^.ConvData^ DO BEGIN
                 {Kanal, in den eingeloggt werden soll, 'rausfinden}
                 VAL(S,AktChan,tmp);
                 IF tmp <> 0 THEN AktChan := 0;

                 Channels := NIL;
                 Call := Klein(CutSSID(KS[ch]^.Call));
                 Host := Klein(OwnConvData^.HostName);
                 Via_Host := '';
                 Away := FALSE;
                 AwayText := '';
                 Verb := FALSE;
                 LastInviChan := 0;
                 RX_Bytes := 0;
                 TX_Bytes := 0;

                 S := 'conversd @ '+OwnConvData^.Hostname+' MCUT-'+WhatIsThis+' '+ConvRelease+' - Type /HELP for help.';
                 SendString(ch,S+#13);
                 Login2Channel(ch,AktChan);
               END;
             END;
           END;
      110: HostCommands(ch,S);
  {$ENDIF}
{$ENDIF}
{$IFDEF CONVNEU}
    111: AuswertConversCommand(ch,S);
{$ENDIF}
  END;
END;


{Wird aufgerufen, wenn die Verbindung disconnected wurde}
PROCEDURE ConvDisconnect(ch: BYTE);
VAR tmp: pConvUserChan;
    {$IFDEF CONVNETZ}
    tmp2: pHostListe;
    last,tmp3,tmp4: pExtUser;
    {$ENDIF}
    S: STRING;
    Found: BOOLEAN;
BEGIN
  CASE KS[ch]^.status OF
      6: BEGIN
           tmp := KS[ch]^.ConvData^.Channels;

           WHILE (tmp<>NIL) DO BEGIN
             BenachrichtigeChannelUser_Disconnect(ch,tmp^.Channel,'link failure');
             DelOneUserAtChannel(tmp^.Channel);

             tmp := tmp^.next;
           END;

           WHILE KS[ch]^.ConvData^.Channels<>NIL DO BEGIN
             tmp := KS[ch]^.ConvData^.Channels^.Next;
             dispose(KS[ch]^.ConvData^.Channels);
             KS[ch]^.ConvData^.Channels := tmp;
           END;
         END;
  {$IFDEF CONVNETZ}
    110: BEGIN

           {In der Host-Liste den Status auf 0 setzen}
           IF KS[ch]^.ConvHost=NIL THEN
             exit;
           tmp2 := HostDataRoot;
           Found := FALSE;
           WHILE (tmp2<>NIL) AND NOT Found DO BEGIN
             IF tmp2^.Hostname=KS[ch]^.ConvHost^.Hostname THEN BEGIN
               Write(#7);
               Found := TRUE;
               tmp2^.State := 0;
               tmp2^.RX_Qual := 0;
               tmp2^.TX_Qual := 0;
               tmp2^.LastPing := 0;
               tmp2^.Since := AktUnixTime;
               tmp2^.Tries := 0;
               tmp2^.RX_Bytes := 0;
               tmp2^.TX_Bytes := 0;
             END
             ELSE tmp2 := tmp2^.next;
           END;

           {User aus der Userliste austragen}
           tmp3 := ExtUserRoot;
           last := NIL;
           WHILE tmp3<>NIL DO BEGIN
             IF tmp3^.Via_Host=KS[ch]^.ConvHost^.Hostname THEN BEGIN
               BenachrichtigeChannelUser_Disconnect(ch,tmp3^.Channel,OwnConvData^.Hostname+'<>'+tmp3^.Via_Host+' broken');
               IF last<>NIL THEN BEGIN
                 last^.next := tmp3^.next;      {Diesen Eintrag berspringen}
                 tmp4 := tmp3;
                 tmp3 := tmp3^.next;
                 dispose(tmp4);
               END
               ELSE BEGIN
                 ExtUserRoot := tmp3^.next;
                 tmp4 := tmp3;
                 dispose(tmp4);
               END;
             END
             ELSE BEGIN
               last := tmp3;
               tmp3 := tmp3^.next;
             END;
           END;
           DISPOSE(KS[ch]^.convHost);
           KS[ch]^.ConvHost:=NIL;
         END;
  {$ENDIF}
  END;

END;


END.

{

  Status-ID's benutzt im Convers:

    6: Normaler Convers-User
  101: Host-Verbindung wird aufgebaut
  110: PingPong-Verbindung besteht
  111: MCuT-Hostverbindung besteht

}
