UNIT INPUT; {MCUT - Unit fr Eingabe - Fenster}

INTERFACE

USES IADVAR;

  PROCEDURE DlgHandleKey;
  PROCEDURE DlgDone(ok:BOOLEAN);
  PROCEDURE DlgInit(x,y,akt:BYTE);
  PROCEDURE DlgTitle(title:STRING);
  PROCEDURE DlgOkButton(x1,y1,r:BYTE;title:STRING20);
  PROCEDURE DlgAbortButton(x1,y1:BYTE;title:STRING20);
  PROCEDURE DlgLabel(x1,y1,len1:byte;title:STRING);
  PROCEDURE DlgText(x1,y1:byte;title:STRING);
  PROCEDURE DlgStr(x1,y1,len1:BYTE;s:POINTER);
  PROCEDURE DlgCheck(x1,y1,len1:BYTE;txt:string;s:POINTER);
  PROCEDURE DlgCheckBit(x1,y1,len1:BYTE;txt:string;s:POINTER;bit:longint);
  PROCEDURE DlgRadio(x1,y1,len1,nr:BYTE;txt:string;s:POINTER);
  PROCEDURE DlgIntStr(x1,y1,len1:BYTE;s:POINTER);
  {PROCEDURE DlgFileSelect(x1,y1,_y2:BYTE;txt:string;s:POINTER);}
  PROCEDURE DlgDraw;

VAR DlgResult:BYTE;
    LastConsole:BYTE;
IMPLEMENTATION

USES VIDEO,CRT,MENUE,KEYMAKRO,TOOLBOX,SCREEN;

TYPE

  TDlgElement=RECORD
    TYP,
    x,y,y2,
    size,
    len:Byte;
    res:longint;
    data,
    olddata:POINTER;
    lab:BOOLEAN;
  END;
  DirArray=ARRAY[1..1000] OF STRING12;
  DirData=RECORD
    Anz  : WORD;
    Pos  : WORD;
    y_POS: BYTE;
  END;

CONST
  StrSet : SET OF CHAR = [#32..#255];
  DosSet : SET OF CHAR= [#33,#35..#38,#40,#41,#45,#46,#48..#58,#65..#90,#92,#95,#95,
                  #97..#122,#126];
  IntSet : SET OF CHAR =['0'..'9','$'];
  RealSet: SET OF CHAR = ['0'..'9','.'];
  MaxElement=80;
  MaxDirSize:BYTE=255;

VAR   DlgElemente   : ARRAY[1..MaxElement] OF ^TDlgElement;
      anzElemente   : BYTE;
      aktElement    : BYTE;
      X_size,Y_Size : BYTE;
      LeerZeile     : STRING[80];
      aktString     : STRING[80];
      akt_len,                   {die maximale lnge dieses string}
      x_abs,                    {die absolutposition des string}
      y_abs,
      x_pos,                        {die relativ position des string}
      in_typ,                   {das eingabeformat, 0=alphanum,1=num,
                                 2=logisch etc}
      Aktive_elemente:BYTE;

FUNCTION DlgElementStr(nr:BYTE):STRING;
BEGIN
  IF nr=0 THEN
    DlgElementStr:=''
  ELSE
  WITH DlgElemente[nr]^ DO
  BEGIN
    CASE typ OF
      0,1,2,3,4,5,6,7,8:DlgElementStr:=STRING(data^);
      9,11: IF Boolean(data^) THEN DlgElementstr:='[X]' else
         DlgElementstr:='[ ]';
     10: IF (pred(res)=BYTE(data^)) THEN DlgElementstr:='(*)' else
         DlgElementstr:='( )';
    END;
  END;
END;


PROCEDURE MakeAktElement;
BEGIN
  IF aktElement=0 THEN
    aktstring:=''
  ELSE
  WITH DlgElemente[aktElement]^ DO
  BEGIN
    aktString:=DlgElementStr(aktElemenT);;
    akt_len:=len;
    x_pos:=length(aktstring)+1;
    in_typ:=typ;
  END;
END;

PROCEDURE DlgRewriteAktElement;
BEGIN
  IF AktElement>0 THEN
  WITH DlgElemente[aktelement]^ DO
  BEGIN
    CASE typ OF
      0,1,2,3,4,5,6: STRING(data^):=AktString;
      9,11        : BOOLEAN(data^):=AktString[2]='X';
      10       : IF AktString[2]='*' THEN BYTE(data^):=pred(res)
                 ELSE BYTE(data^):=succ(res);
    END;
  END;
END;

PROCEDURE DlgDrawAktivElement;
BEGIN
  IF AktElement=0 THEN exit;
  WITH DlgElemente[aktelement]^ DO
  BEGIN
    PrintS(pred(x_abs+x),pred(y_abs+y),aktString,fDlgAktiv);
    leerzeile[0]:=CHAR(len-BYTE(aktstring[0]));
    PrintS(x_abs+x+length(aktstring)-1,Pred(y_abs+y),leerzeile,fDlgAktiv);
  END;
END;

PROCEDURE DlgDrawInAktivElement(b:byte);
VAR farbe:BYTE;
    S:STRING[80];
BEGIN
    WITH DlgElemente[b]^ DO
    BEGIN
      CASE typ OF
        0 :farbe:=FdlgTitel;
      1,2,3,4,9,10,11:Farbe:=FDlgInAktiv;
      5,6:Farbe:=FdlgButton;
         7:Farbe:=FdlgBackGround;
         8:IF (b>1) AND (pred(b)=aktelement) THEN
             Farbe:=fDlgAktiv
           ELSE
             Farbe:=fDlgInaktiv;
      END;
      S:=DlgElementStr(b);
      PrintS(pred(x_abs+x),pred(y_abs+y),S,farbe);
      leerzeile[0]:=CHAR(len-BYTE(s[0]));
      PrintS(x_abs+x+length(s)-1,pred(y_abs+y),leerzeile,farbe);
   END;
END;

PROCEDURE DlgDraw;
VAR B:BYTE;
    
BEGIN
  IF ScreenWriteOk THEN
  BEGIN
    Rahmen(x_abs,y_abs,x_abs+x_size+1,y_abs+y_size+1,1,TRUE,FDlgBackGround);
    FOR b:=1 TO anzElemente DO
      IF b<>AktElement THEN
        DlgDrawInAktivElement(b);
    DlgDrawAktivElement;
    XGotoXY(x_abs+DlgElemente[aktelement]^.x+x_pos-2,y_abs+DlgElemente[aktelement]^.y-1);
  END;
END;

PROCEDURE DlgInit(x,y,akt:BYTE);
VAR b:BYTE;
BEGIN
  aktive_elemente:=0;
  x_abs:=x;
  y_abs:=y;
  for B:=1 to AnzElemente DO
    IF DlgElemente[b]^.typ IN [1..6] THEN
     inc(aktive_elemente);
  aktelement:=akt;
  MakeAktElement;
  dec(x_size);dec(y_size);
  DlgDraw;
  LastConsole:=ConsoleState;
  ConsoleState:=4;
  
END;

PROCEDURE DlgTitle(title:STRING);
BEGIN
  Inc(anzElemente);
  New(DlgElemente[anzElemente]);
  WITH DlgElemente[anzElemente]^ DO
  BEGIN
    lab:=FALSE;
    TYP:=0;
    size:=length(title)+1;
    Getmem(data,size);
    string(data^):=Title;
    len:=pred(size);
    y:=1;
    x:=abs((x_size DIV 2)-(len DIV 2));
    if x+len>x_size THEN x_size:=x+len;
    if y>y_size THEN y_size:=Y;
  END;
END;


PROCEDURE DlgOkButton(x1,y1,r:BYTE;title:STRING20);
BEGIN
  Inc(anzElemente);
  New(DlgElemente[anzElemente]);
  WITH DlgElemente[anzElemente]^ DO
  BEGIN
    lab:=FALSE;
    IF R>0 THEN
      TYP:=5
    ELSE TYP:=6;
    RES:=r;
    size:=length(title)+1;
    Getmem(data,size);
    string(data^):=Title;
    len:=pred(size);
    y:=y1;
    x:=x1;
    if x+len>x_size THEN x_size:=x+len;
    if y>y_size THEN y_size:=Y;
  END;
END;


PROCEDURE DlgAbortButton(x1,y1:BYTE;title:STRING20);
BEGIN
  DlgOkButton(x1,y1,0,title);
END;

PROCEDURE DlgText(x1,y1:byte;title:STRING);
BEGIN
  Inc(anzElemente);
  New(DlgElemente[anzElemente]);
  WITH DlgElemente[anzElemente]^ DO
  BEGIN
    lab:=FALSE;
    TYP:=7;
    size:=length(title)+1;
    Getmem(data,size);
    string(data^):=Title;
    len:=pred(size);
    y:=y1;
    x:=x1;
    if x+len>x_size THEN x_size:=x+len;
    if y>y_size THEN y_size:=Y;
  END;
END;

PROCEDURE DlgLabel(x1,y1,len1:byte;title:STRING);
BEGIN
  Inc(anzElemente);
  New(DlgElemente[anzElemente]);
  WITH DlgElemente[anzElemente]^ DO
  BEGIN
    lab:=FALSE;
    TYP:=8;
    size:=length(title)+1;
    Getmem(data,size);
    string(data^):=Title;
    len:=len1;
    y:=y1;
    x:=x1;
    IF anzElemente>1 THEN
      DlgElemente[PRED(anzElemente)]^.LAB:=TRUE;
    if x+len>x_size THEN x_size:=x+len;
    if y>y_size THEN y_size:=Y;
  END;
END;

PROCEDURE DlgStr_i(x1,y1,len1,typ1:BYTE;s:POINTER);
BEGIN
  Inc(anzElemente);
  New(DlgElemente[anzElemente]);
  WITH DlgElemente[anzElemente]^ DO
  BEGIN
    lab:=FALSE;
    typ:=typ1;
    size:=len1+1;
    Getmem(data,size);
    string(data^):=string(s^);
    IF byte(STRING(data^)[0])>len1 THEN
       byte(STRING(data^)[0]):=len1;
    olddata:=s;
    len:=len1;
    y:=y1;
    x:=x1;
    if x+len>x_size THEN x_size:=x+len;
    if y>y_size THEN y_size:=Y;
  END;
END;
PROCEDURE DlgStr(x1,y1,len1:BYTE;s:POINTER);
BEGIN
  DlgStr_i(x1,y1,len1,1,s);
END;
PROCEDURE DlgDosStr(x1,y1,len1:BYTE;s:POINTER);
BEGIN
  DlgStr_i(x1,y1,len1,2,s);
END;
PROCEDURE DlgIntStr(x1,y1,len1:BYTE;s:POINTER);
BEGIN
  DlgStr_i(x1,y1,len1,3,s);
END;

PROCEDURE DlgChRa(x1,y1,len1,satz:BYTE;txt:string;s:POINTER);
BEGIN
  Inc(anzElemente);
  New(DlgElemente[anzElemente]);
  WITH DlgElemente[anzElemente]^ DO
  BEGIN
    if satz>0 THEN
    typ:=10 ELSE
     typ:=9;
    size:=1;
    res:=satz;
    Getmem(data,1);
    {$R-}
    BYTE(data^):=BYTE(s^);
    olddata:=s;
    len:=3;
    y:=y1;
    x:=x1;
    if x+3>x_size THEN x_size:=x+len;
    if y>y_size THEN y_size:=Y;
  END;
  DlgLabel(x1+3,y1,succ(len1),' '+txt);
END;
PROCEDURE DlgCheck(x1,y1,len1:BYTE;txt:string;s:POINTER);
BEGIN
  DlgChRa(x1,y1,len1,0,txt,s);
END;

PROCEDURE DlgRadio(x1,y1,len1,nr:BYTE;txt:string;s:POINTER);
BEGIN
  DlgChRa(x1,y1,len1,succ(nr),txt,s);
END;

PROCEDURE DlgCheckBit(x1,y1,len1:BYTE;txt:string;s:POINTER;bit:longint);
BEGIN
  Inc(anzElemente);
  New(DlgElemente[anzElemente]);
  WITH DlgElemente[anzElemente]^ DO
  BEGIN
    typ:=11;
    size:=1;
    res:=bit;
    Getmem(data,1);
    BOOLEAN(data^):=(LONGINT(s^) AND bit)<>0;
    olddata:=s;
    len:=3;
    y:=y1;
    x:=x1;
    if x+3>x_size THEN x_size:=x+len;
    if y>y_size THEN y_size:=Y;
  END;
  DlgLabel(x1+3,y1,succ(len1),' '+txt);
END;

{PROCEDURE DlgFileSelect(x1,y1,_y2:BYTE;s:POINTER);
BEGIN
  Inc(anzElemente);
  New(DlgElemente[anzElemente]);
  WITH DlgElemente[anzElemente]^ DO
  BEGIN
    size:=70;
    GetMem(data,71);
    STRING(data^):=STRING(s^);
    olddata:=s;
    len:=30;
    y:=y1;
    x:=x1;
    if x+3>x_size THEN x_size:=x+len;
    if y>y_size THEN y_size:=Y;
  END;
  Inc(anzElemente);
  New(DlgElemente[anzElemente]);
  WITH DlgElemente[anzElemente]^ DO
  BEGIN
    size:=13*MaxDirSize;
    GetMem(data,size);
    y:=succ(y1);
    x:=x1;
    y2:=_Y2;
    DirAnz:=0;
    IF x+3>x_size THEN x_size:=x+len;
    IF y2>y_size THEN y_size:=Y2;
  END;
END;
}
PROCEDURE DlgDone(ok:BOOLEAN);
VAR B:BYTE;
BEGIN
 FOR b:=1 to anzElemente DO
      WITH dlgElemente[b]^ DO
 BEGIN
   IF ok AND (dlgELemente[b]^.TYP IN [1..4,9]) THEN
       MOVE(data^,olddata^,size);
   IF ok AND (TYP=10) AND (BYTE(Data^)=pred(res)) THEN
     BYTE(OldData^):=pred(res);
   IF ok AND (dlgElemente[b]^.TYP=11) THEN
   BEGIN
     IF BOOLEAN(Data^) THEN
       LONGINT(OldData^):=LONGINT(OldData^) OR res
     ELSE
       LONGINT(OldData^):=LONGINT(OldData^) AND NOT res;
   END;
   Freemem(data,size);
   Dispose(dlgElemente[b]);
 END;
 anzElemente:=0;
 x_size:=0;
 y_size:=0;
 ConsoleState:=LastConsole;
 IF ins_mode THEN
   Cursor(2)
 ELSE
   Cursor(1);
 RedrawScreen;
END;

PROCEDURE DlgMove(UP:BOOLEAN);
VAR alt_el:BYTE;
BEGIN
  IF aktive_Elemente>1 THEN
  BEGIN
    DlgReWriteAktElement;
    DlgDrawInAktivElement(aktElement);
    alt_el:=aktelement;
    REPEAT
      IF UP THEN
      BEGIN
        INC(aktElement);
        IF aktelement>anzelemente THEN
          aktElement:=1;
      END ELSE
      BEGIN
        DEC(aktElement);
        IF aktelement=0 THEN
          aktElement:=anzElemente;
      END;
    UNTIL DlgElemente[aktElement]^.TYP IN [1..6,9,10,11];
    MakeAktElement;
    IF in_typ IN [1..4] THEN
    BEGIN
      IF ins_mode THEN Cursor(2) ELSE
        Cursor(1);
    END ElSE Cursor(0);
    DLgDrawAktivElement;
    IF DlgElemente[aktelement]^.lab THEN
      DlgDrawInAktivElement(succ(aktelement));
    IF Dlgelemente[alt_el]^.lab THEN
      DlgDrawInAktivElement(succ(alt_el));
  END;
END;

PROCEDURE DlgHandleKey;
VAR TASTE:CHAR;B:BYTE;
BEGIN
  taste:=XREADKEY;
  CASE taste OF
   #27:BEGIN
         DlgDone(FALSE);
         DlgResult:=0;
         exit;
       END;
   #32..#255:
     BEGIN
       CASE in_typ of
         1:IF NOT (taste IN StrSet) THEN exit;
         2:IF NOT (taste IN DosSet) THEN exit;
         3:IF NOT (taste IN IntSet) THEN exit;
         4:IF NOT (taste IN RealSet) THEN exit;
         5,6:exit;
         9,11:BEGIN
            IF taste=#32 THEN
            BEGIN
              IF aktstring[2]='X' THEN aktstring[2]:=' ' ELSE
                aktString[2]:='X';
              DlgDrawAktivElement;
              exit;
            END;
          END;
         10:BEGIN
            IF taste=#32 THEN
            BEGIN
              IF aktstring[2]=' ' THEN;
              BEGIN
                FOR B:=1 TO AnzElemente DO
                IF (DlgElemente[b]^.TYP=10) AND (DlgElemente[b]^.OldData=DlgElemente[aktElement]^.OldData) THEN
                BEGIN
                  BYTE(DlgElemente[b]^.data^):=Pred(DlgElemente[AktElement]^.res);
                  DlgDrawInAktivElement(b);
                  DlgDrawInaktivElement(succ(b));
                END;
                aktstring[2]:='*';
                DlgDrawAktivElement;
              END;
              exit;
            END;
          END;
       END;
       IF ins_mode THEN
       BEGIN
         IF length(aktstring)<akt_len THEN
         BEGIN
           Insert(taste,aktstring,x_pos);
           inc(x_pos);
         END;
       END
       ELSE
       BEGIN
         IF x_pos>=length(aktstring) THEN exit;
         aktstring[x_pos]:=taste;
         IF x_pos>Length(aktstring) THEN
           aktstring[0]:=CHAR(x_pos);
         inc(x_pos);
       END;
      END;
     #9:{Tabulator}
        DlgMove(TRUE);
     #8:{Backspace}
        IF (in_typ>0) AND (in_typ<5) THEN
        IF x_pos>1 THEN
        BEGIN
          DEC(x_pos);
          Delete(aktstring,x_pos,1);
        END;
     #25:{Control-Y}
        IF (in_typ>0) AND (in_typ<5) THEN
        BEGIN
          aktstring:='';
          x_pos:=1;
        END;
     #13:{Return}
        BEGIN
          DlgReWriteAktElement;
          CASE in_typ OF
              5:DlgResult:=DlgELemente[aktElement]^.res;
              6:DlgResult:=0;
          ELSE
            dlgResult:=1;
          END;
          IF in_typ=6 THEN
            DlgDone(FALSE)
          ELSE
            DlgDone(TRUE);
          exit;
        END;
     #18:{STRG-R}
         IF (in_typ>0) AND (in_typ<5) THEN
         BEGIN
           Move(DlgElemente[aktElement]^.oldData^,DlgElemente[aktElement]^.Data^,
                DlgElemente[aktElement]^.size);
           MakeAktElement;
         END;
     #0:BEGIN
          taste:=Xreadkey;
          CASE Taste OF
              #9:DlgMove(FALSE);
            #77:{Pfeil rechts}
                IF (in_typ>0) AND (in_typ<5) THEN
                IF x_pos<length(aktstring)+1 THEN INC(x_pos);
            #75:{Pfeil links}
                IF (in_typ>0) AND (in_typ<5) THEN
                IF x_pos>1 THEN DEC(x_pos);
            #71:{POS1}
                IF (in_typ>0) AND (in_typ<5) THEN
                  x_pos:=1;
            #79:{END}
                IF (in_typ>0) AND (in_typ<5) THEN
                  x_pos:=Length(aktstring)+1;
            #80:{pfeil unten}
                BEGIN
                  DLgMove(TRUE);
                END;
            #72:{pfeil oben}
                BEGIN
                  DlgMove(FALSE);
                END;
            #82:{insert}
                IF IN_TYP IN [1..4] THEN
                BEGIN
                  ins_mode:=NOT ins_mode;
                  IF ins_mode THEN Cursor(2) ELSE
                   Cursor(1);
                END;
            #83:{del}
                IF (in_typ>0) AND (in_typ<5) THEN
                BEGIN
                  Delete(aktstring,x_pos,1);
                END;
            #115:{strg-rechts};
            #116:{STRG-links};
          END;
       END;
  END;
  DlgDrawAktivElement;
  XGotoXY(x_abs+DlgElemente[aktelement]^.x+x_pos-2,y_abs+DlgElemente[aktelement]^.y-1);
END;

BEGIN
  fillChar(leerzeile[1],80,' ');
  leerzeile[0]:=#80;
  AnzElemente:=0;
  x_size:=0;
  y_size:=0;
END.
