UNIT VIDEO;


INTERFACE
USES CRT,DOS,TOOLBOX;

PROCEDURE PrintCH(X,Y: BYTE; Zeichen: CHAR; Attrib: BYTE);
PROCEDURE PrintS(X, Y: BYTE; S: STRING; Attrib: BYTE);
{$IFNDEF linux}
{FUNCTION VGA_Vorh: BOOLEAN;}
{$ENDIF}
FUNCTION Zeichen(X,Y:BYTE): CHAR;
{$IFNDEF linux}
{PROCEDURE ScrollSlowWeg;}
{$ENDIF}
PROCEDURE ChangeColor(X,Y,Attrib,Anz: BYTE);
PROCEDURE Rahmen(x1,y1,x2,y2,Art:BYTE; Schatten: BOOLEAN;color:BYTE);
PROCEDURE Fill(x1, y1: BYTE; x2, y2: BYTE; z: CHAR; color: BYTE);
PROCEDURE WriteAttribString(X,Y: BYTE; S: STRING; Attrib: BYTE);
PROCEDURE UpdateScreen;
PROCEDURE UpdateBuf;

VAR
    Screen		: WORD;               {Start-Segment des Bildschirmspeichers}
    VideoRam		: WORD;
   StdWinMin, StdWinMax	: WORD;

IMPLEMENTATION
{$IFDEF linux}
   {$DEFINE CRT}
{$ENDIF}
{$IFNDEF FPK}
USES  Memory,mystring;
{$ENDIF}

CONST XMax = 80;                {Maximale Anzahl Zeichen in X}

VAR Color: BOOLEAN;             {Farb-Monitor vorhanden?}
    Buffer:Pointer;
{ $DEFINE CRT}

{$IFNDEF crt}
                       (*
procedure FastMove(var source, dest; count: word); assembler;
{count must be evenly dividible by 4 !}
asm
 cld
 mov cx,count
 lds si,source
 cmp cx,0
 les di,dest
 je @end

 cmp test8086,2
 jle @no386

 shr cx,2

 @loop:
 db $66; mov ax,[si]
 db $66; mov es:[di],ax
 dec cx
 add si,4
 add di,4
 cmp cx,0
 jne @loop
 jmp @end

@no386:
 shr cx,1
 rep movsw

@end:
 mov ax, seg @data
 mov ds,ax
end;
*)

VAR INFO:BYTE; err:integer;

PROCEDURE UpdateScreen;
BEGIN
  Move(Buffer^,ptr(VideoRAM,0)^,succ(_zeilen)*_spalten*2);
END;  

PROCEDURE UpdateBuf;
BEGIN
  Move(ptr(VideoRAM,0)^,Buffer^,succ(_zeilen)*_spalten*2);
END;  

{Schreib das mit 'Zeichen' angegebene Zeichen 'Anz' mal
 (Entspricht STRING$ aus Basic}
FUNCTION StringD(Zeichen: CHAR; Anz: WORD): STRING; Assembler;
ASM
  PUSH DS
  CLD                           {Lschen des Richtungsflags}
  LES DI,@Result                {Ergebnis der Funktion nach ES:[DI]}
  MOV CX,Anz                    {Anzahl nach CL}
  MOV ES:[DI],CL                {Anzahl als Byte 0 in den String}
  INC DI
  MOV AL,Zeichen                {Zeichen nach AL}
  REP STOSB                     {Zeichen Anz mal in den Ergebnisstring
                                 schreiben}
  POP DS
END;


{Schreibt ein Zeichen direkt in den Bildschirmspeicher}
PROCEDURE _PrintCH(X,Y: BYTE; Zeichen: CHAR; Attrib: BYTE); Assembler;
ASM
  DEC(X);
  DEC(Y);
  PUSH SI
  MOV AX,Screen                 {Bildschirmseite 0 nach AX}
  MOV ES,AX                     {Und weiter nach ES}
  MOV AX,XMax
  MOV BL,2
  MUL BL
  MUL Y                         {AX := AX * Y}
  MOV SI,AX                     {SI := AX}
  MOV AX,2
  MUL X                         {AX := AX * X}
  ADD SI,AX                     {SI := SI + AX}
  MOV AH,Zeichen                {Das zu schreibende Zeichen nach AH}
  MOV ES:[SI],AH                {Zeichen in den Speicher schreiben}
  MOV AH,Attrib
  MOV ES:[SI+1],AH              {Attribut des Zeichens nach AH}
  POP SI
END;

PROCEDURE PrintCH(X,Y: BYTE; Zeichen: CHAR; Attrib: BYTE);
BEGIN
   if (X>80) OR (Y>25) THEN
   BEGIN
      {WriteLN('X:',X,'Y:',Y);READLN;}EXIT;
   END ELSE   
      _printch(x,y,zeichen,attrib);
END;   
{Schreibt einen ganzen String direkt in den Bildschirmspeicher}
PROCEDURE _PrintS(X, Y: BYTE; S: STRING;Attrib: BYTE); Assembler;
ASM
  DEC X
  DEC Y
  PUSH DS
  {Jetzt ist die Adresse im Bildschirmspeicher in DI}
  MOV AX,Screen         {Segment-Adresse des Bildschirmspeichers nach AX}
  MOV ES,AX             {Und weiter nach ES}

  CLD
  LDS SI,S              {Adresse von S nach DS:SI}
  {Gucken, ob berhaupt ein String bergeben wurde}
  MOV AL,DS:[SI]
  CMP AL,0
  JE @Fertig

  MOV AX,XMax
  MOV BL,2
  MUL BL
  MUL Y                 {AX := AX * Y  ->  AX := 160 * Y}
  MOV DI,AX             {DI := AX}
  MOV AX,2
  MUL X                 {AX := AX * X  ->  AX := 2 * X}
  ADD DI,AX             {DI := DI + AX}

  XOR CX,CX
  MOV CL,DS:[SI]        {Lngen-Byte nach CX}
  INC SI                {SI := SI + 1}
  @Schleife:
  MOV AH,DS:[SI]
  MOV ES:[DI],AH        {Erstes Zeichen schreiben}
  INC SI                {SI := SI + 1 (Ein Zeichen weiter)}
  MOV AH,Attrib
  MOV ES:[DI+1],AH      {Attribut-Byte in den Bildschirmspeicher schreiben}
  ADD DI,2
  LOOP @Schleife
  @Fertig:

  POP DS
END;
PROCEDURE PrintS(X,Y: BYTE; S:STRING; Attrib: BYTE);
BEGIN
   if ((X+length(s))>82) OR (Y>25) THEN
   BEGIN
      {WriteLN('X:',X+length(s),'Y:',Y);READLN;}EXIT;
   END ELSE   
      _prints(x,y,S,attrib);
END;   


{Liefert als ergebnis TRUE zurck, wenn eine VGA-Karte installiert
 ist - sonst FALSE}
FUNCTION VGA_Vorh: BOOLEAN;
VAR Hlp,Karte: BYTE;
BEGIN
  ASM
    MOV AH,1Ah                  {Int 10h, Func 1Ah: Grafikkarten-gedns
                                 (VGA-Karten und PS/2-rechner untersttzen
                                 dies)}
    MOV AL,00h
    INT 10h                     {Interrupt-Aufruf}
    MOV Hlp,AL
    MOV Karte,BL
  END;
  IF (Hlp=26) AND (Karte=8) THEN VGA_Vorh := TRUE
                            ELSE VGA_Vorh := FALSE;
END;



FUNCTION Zeichen(X,Y:BYTE): CHAR;
VAR Zeich: CHAR;
BEGIN
  ASM
    PUSH DS
    CLD

    DEC X
    DEC Y

    {Aktuelle Bildschirmseite einlesen}
    PUSH ES                               {ES sichern}
    XOR AX,AX                             {AX leer machen (0)}
    MOV ES,AX                             {AX nach ES schreben (=ES := 0)}
    MOV BH,BYTE PTR ES:[462h]             {Aktuelle bildschirmseite nach BH}
    POP ES                                {ES zurck schreiben}

    {Adresse des Zeichens nach SI}
    MOV AX,XMax
    MOV DL,2
    MUL DL
    MUL Y
    MOV SI,AX
    MOV AX,2
    MUL X
    ADD SI,AX

    MOV AX,Screen
    MOV ES,AX
    MOV AX,100h
    MUL BH
    MOV BX,ES
    ADD BX,AX
    MOV ES,BX

    MOV AH,ES:[SI]
    MOV Zeich,AH

    POP DS
  END;
  Zeichen := Zeich;
END;


PROCEDURE ScrollSlowWeg;
VAR I: INTEGER;
BEGIN
  port[$3d4] := 8;
  port[$3d5] := 12;
  FOR i := 1 TO 25 DO BEGIN
    port[$3d4] := 8;
    port[$3d5] := 0;
    GOTOXY(1,1);
    DELLINE;
    port[$3d4] := 8;
    port[$3d5] := 12;
  END;
  port[$3d4] := 8;
  port[$3d5] := 0;
END;


{ndert nur das Attribut-Byte an der angegebenen Bildschirmstelle
 fr Anz Zeichen}
PROCEDURE ChangeColor(X,Y,Attrib,Anz: BYTE); Assembler;
ASM
  DEC X                 {Oben Links fr Pascal: 1 - ASM: 0}
  DEC Y                 {Deshalb je 1 abziehen}
  MOV AX,XMax
  MOV BL,2
  MUL BL
  MUL Y                 {AX := AX * Y  ->  AX := 160 * Y}
  MOV DI,AX             {DI := AX}
  MOV AX,2
  MUL X                 {AX := AX * X  ->  AX := 2 * X}
  ADD DI,AX             {DI := DI + AX}

  MOV AX,Screen
  MOV ES,AX             {Offset-Adresse von Bildschirmseite 0 nach ES}

  XOR CX,CX             {CX := 0}
  MOV CL,Anz            {Anzahl nach CL}
  MOV AL,Attrib         {Attribut-Byte nach AL}

  @Schleife:
    MOV ES:[DI+1],AL    {Attribut-Byte schreiben}
    ADD DI,2
  LOOP @Schleife

END;



PROCEDURE Fill(x1, y1: BYTE; x2, y2: BYTE; z: CHAR; color: BYTE);
VAR i: BYTE;
    S: STRING;
BEGIN
  S := StringD(z,x2-x1+1);
  FOR i := y1 TO y2 DO PrintS(x1,i,S,color);
END;

(*
 * Diese Prozedur ist von Jochen,
 * sie schreibt einen String in den Bildschirmspeicher, wobei sie
 * im String auftauchende #0 so interpretiert, da das folgende BYTE
 * als Farb-Attribut geladen wird.
 *)
{$IFDEF f}
   
PROCEDURE WriteAttribString(X,Y: BYTE; S: STRING; Attrib: BYTE); Assembler;
VAR len: BYTE;
ASM
  MOV len,0
  DEC X
  DEC Y
  PUSH DS
  {Jetzt ist die Adresse im Bildschirmspeicher in DI}
  MOV AX,Screen         {Segment-Adresse des Bildschirmspeichers nach AX}
  MOV ES,AX             {Und weiter nach ES}

  CLD
  LDS SI,S              {Adresse von S nach DS:SI}
  {Gucken, ob berhaupt ein String bergeben wurde}
  MOV AX,XMax
  MOV BL,2
  MUL BL
  MUL Y                 {AX := AX * Y  ->  AX := 160 * Y}
  MOV DI,AX             {DI := AX}
  MOV AX,2
  MUL X                 {AX := AX * X  ->  AX := 2 * X}
  ADD DI,AX             {DI := DI + AX}
  MOV AL,DS:[SI]
  MOV CL,AL
  CMP AL,0
  JE @Fertig

  XOR CX,CX
  MOV CL,DS:[SI]        {Lngen-Byte nach CX}
  MOV DL,80
  INC SI                {SI := SI + 1}
  @Schleife:
  MOV AH,DS:[SI]
  CMP AH,0
  JE @NeuAttrib
  DEC DL
  CMP DL,0
  JZ @ende 
  MOV ES:[DI],AH        {Erstes Zeichen schreiben}
  INC len
  INC SI                {SI := SI + 1 (Ein Zeichen weiter)}
  MOV AH,Attrib
  MOV ES:[DI+1],AH      {Attribut-Byte in den Bildschirmspeicher schreiben}
  ADD DI,2
  JMP @weiter
  @NeuAttrib:
  INC SI                {nchstes Zeichen ist das neue Attribut}
  DEC CX                {einen Schleifendurchlauf weniger}
  JCXZ @Fertig
  MOV AH,DS:[SI]
  MOV attrib,AH
  INC SI
  @weiter:
  LOOP @Schleife
  @Fertig:

  {**************** Den Rest der Zeile mit SPACES auffllen ****************}
  {CX := XMax - BL (Lngenbyte) - AktX (wo fangen wir an zu schreiben?)}
  MOV CX,0
  MOV CL,XMax
  SUB CL,len
  (*SUB CL,X *)
  jcxz @ende
  {Mit welchem Zeichen auffllen? (SPACE)}
  MOV AL,32
  {Mit welchem Attribut?}
  MOV AH,attrib
  @Auffuellen:
    MOV ES:[DI],AX
    ADD DI,2
  LOOP @Auffuellen;  
  @ende:
  POP DS
END;
{$ELSE}
PROCEDURE WriteAttribString(X,Y: BYTE; S: STRING; Attrib: BYTE);
VAR B,offs:WORD;S2:STRING;
BEGIN
   if y>_zeilen then
  begin
     exit;
     
  end;{$IFDEF linux}
  GotoXY(X,Y);
   {$ENDIF}

  S2:='';
  B:=1;
  offs:=0;
  WHILE B<=LENGTH(S) DO
  BEGIN
   IF S[B]=#0 THEN
   BEGIN
     IF S2<>'' THEN prints(x+offs,y,S2,attrib);
     offs:=offs+length(s2);
     S2:='';
     INC(B);
     Attrib:=BYTE(S[b]);
     INC(B); 
   END ELSE
   BEGIN
     S2:=S2+S[b];  
     INC(b);
   END;  
  END;
   if offs>80 THEN begin
      writeln('offs!');
      exit;
   end;
  IF S2<>'' THEN prints(x+offs,y,S2,attrib);
  offs:=offs+length(s2);
  if x+offs<80 THEN
    prints(x+offs,y,stringd(' ',80-x-offs),attrib);
END;
{$ENDIF}

FUNCTION Segment(X: Pointer): WORD; Assembler;
ASM
  LES SI,X      {Adresse von X nach ES:SI}
  MOV AX,ES     {Segment-Adresse zurck geben}
END;

{$ELSE}


PROCEDURE PrintCH(X,Y: BYTE; Zeichen: CHAR; Attrib: BYTE);
VAR a,b	: WORD;
BEGIN
   {a:=WindMin;b:=WindMax;
   WindMax:=StdWinMax;WindMin:=StdWinMin;}
  GotoXY(X,Y);
  TextColor(Attrib MOD 16);
  TextBackground(Attrib DIV 16);
  Write(Zeichen);
   {WindMax:=a;WindMin:=b;}
END;
PROCEDURE PrintS(X, Y: BYTE; S: STRING; Attrib: BYTE);
VAR a,b	: WORD;
BEGIN
   {
   a:=WindMin;b:=WindMax;
   WindMax:=StdWinMax;WindMin:=StdWinMin;}
  GotoXY(X,Y);
  TextColor(Attrib MOD 16);
  TextBackground(Attrib DIV 16);
   Write(S);
   {WindMax:=a;WindMin:=b;}
END;

FUNCTION Zeichen(X,Y:BYTE): CHAR;
BEGIN
  Zeichen:=' ';
END;

PROCEDURE ChangeColor(X,Y,Attrib,Anz: BYTE);
BEGIN
END;

PROCEDURE Fill(x1, y1: BYTE; x2, y2: BYTE; z: CHAR; color: BYTE);
VAR i: WORD;
    S: STRING;
BEGIN
  S := StringD(z,x2-x1+1);
{  S:='';
  FOR I:=1 TO x2-x1+1 DO S:=S+z;}
  FOR i := y1 TO y2 DO PrintS(x1,i,S,color);
END;

PROCEDURE WriteAttribString(X,Y: BYTE; S: STRING; Attrib: BYTE);
VAR B,offs:WORD;S2:STRING;
BEGIN
  if x>_zeilen then
  begin
     WriteLn(X,Y);READLN;exit;
  end;{$IFDEF linux}
  GotoXY(X,Y);
   {$ENDIF}
  S2:='';
  B:=1;
  offs:=0;
  WHILE B<=LENGTH(S) DO
  BEGIN
   IF S[B]=#0 THEN
   BEGIN
     IF S2<>'' THEN prints(x+offs,y,S2,attrib);
     offs:=offs+length(s2);
     S2:='';
     INC(B);
     Attrib:=BYTE(S[b]);
     INC(B); 
   END ELSE
   BEGIN
     S2:=S2+S[b];  
     INC(b);
   END;  
  END;
   if offs>80 THEN begin
      writeln('offs!');
      exit;
   end;
  IF S2<>'' THEN prints(x+offs,y,S2,attrib);
  offs:=offs+length(s2);
   if (x+offs<=80) AND (y<>_zeilen) THEN
    prints(x+offs,y,stringd(' ',80-x-offs+1),attrib);
END;

PROCEDURE UpdateScreen;
BEGIN
END;

PROCEDURE UpdateBuf;
BEGIN
END;


{$ENDIF}
PROCEDURE Rahmen(x1,y1,x2,y2,Art:BYTE; Schatten: BOOLEAN;color:BYTE);
VAR
    Oben,Unten,Mitte: STRING[80];
    i: BYTE;
BEGIN

  IF Art=1 THEN BEGIN
    Oben := '+'+StringD('-',x2-x1-1)+'+';
    Mitte := '|'+StringD(' ',x2-x1-1)+'|';
    Unten := '+'+StringD('-',x2-x1-1)+'+';
  END
  ELSE BEGIN
    Oben := '+'+StringD('-',x2-x1-1)+'+';
    Mitte := '|'+StringD(' ',x2-x1-1)+'|';
    Unten := '+'+StringD('-',x2-x1-1)+'+';
  END;

  PrintS(x1,y1,Oben,Color);
  PrintS(x1,y2,Unten,Color);
  FOR i := y1+1 TO y2-1 DO PrintS(x1,i,Mitte,Color);
{$IFNDEF LINUX}
  IF Schatten THEN BEGIN
    ChangeColor(x1+2,y2+1,8,x2-x1);
    FOR i := y1+1 TO y2+1 DO ChangeColor(x2+1,i,8,2);
  END;
{$ENDIF}   
END;

BEGIN
  {$IFnDEF crt}
  Buffer:=MemAllocSeg(9600);
  FillChar(Buffer^,9600,0);
  IF Buffer=NIL THEN 
  BEGIN
   WriteLn('AllocSeg failed');halt;
  END; 
  Screen:=Segment(Buffer);
  ASM
    { Startadresse des Bildschirmspeichers ermitteln }
    MOV Color,0
    MOV VideoRam,$b000
    INT 11h
    AND AX,$30
    CMP AX,$30
    JZ @@mono
    MOV Color,1
    MOV VideoRam,$b800
    @@mono:
  END; 
  {$ELSE}
StdWinMin:=WindMin;
StdWinMax:=WindMax;
  {$ENDIF}
END.















