UNIT DIALOG2;
INTERFACE

 PROCEDURE TNCSettingsDlg;
 PROCEDURE TNCSettingsDlg_Auswert;
 PROCEDURE GeneraLSettingsDlg;
 PROCEDURE GeneralSettingsDlg_Auswert;
 PROCEDURE PathSettingsDlg;
 PROCEDURE PathSettingsDlg_Auswert;
 PROCEDURE TerminalSettingsDlg;
 PROCEDURE TerminalSettingsDlg_Auswert;
 PROCEDURE UmlautSettingsDlg;
 PROCEDURE UmlautSettingsDlg_Auswert;
 (*
 PROCEDURE MonitorSettingsDlg;
 PROCEDURE MonitorSettingsDlg_Auswert;
 *)
 PROCEDURE PrioDlg;
 PROCEDURE PrioDlg_Auswert;
 (*
 PROCEDURE MonitorSaveDlg;
 PROCEDURE MonitorSaveDlg_Auswert;
 *)
 PROCEDURE MonitorDlg;
 PROCEDURE MonitorDlg_Auswert;
 PROCEDURE FlexnetDlg;
 PROCEDURE FlexnetDlg_Auswert;
 PROCEDURE ScreenDlg;
 PROCEDURE ScreenDlg_Auswert;
 PROCEDURE DefaultRemotesDlg;
 PROCEDURE DefaultRemotesDlg_Auswert;
IMPLEMENTATION


USES Toolbox,Iadvar,dos,
     input,
     {$IFDEF WA8DED}
     TNC,
     V24DRV,
     {$ENDIF}
     mystring,screen,crt,mcutlib,mcutlib2,startup,packet,mcutbuf;

VAR
    dlgbaudrate:BYTE;
CONST AktSettingsDevice:BYTE = 0;
      Zeilen_Save:INTEGER    = 0;
(*   tfkiss_flag:BYTE	     = 0;*)

PROCEDURE UmlautSettingsDlg;
var B:BYTE;
BEGIN
  Which_Dialog:=12;
  DlgText(2,2,'Empfangs-Tabelle');
  DlgText(36,2,'Sende-Tabelle');
  FOR B:=0 to UmlautTableAnz DO
    DlgRadio(2,3+b,30,b,UmlautDescription[b]^,@KS[channel]^.RXUmlautTable);
  FOR B:=0 to UmlautTableAnz DO
    DlgRadio(36,3+b,30,b,UmlautDescription[b]^,@KS[channel]^.TXUmlautTable);
  DlgOkButton(2,umlauttableanz+4,1,' OK ');
  DlgAbortButton(8,umlauttableanz+4,'ABORT');
  DlgTitle('Umlautwandler');
  DlgInit(5,5,3);
END;

PROCEDURE UmlautSettingsDlg_Auswert;
BEGIN
  Which_Dialog:=0;
END;



PROCEDURE TNCSettingsDlg;
BEGIN
  Which_Dialog:=6;
  BEGIN
    IF Baud = 4800 THEN DlgBaudRate:=1 ELSE
    IF Baud = 9600 THEN DlgBaudRate:=2 ELSE
    IF Baud = 19200 THEN DlgBaudRate:=3 ELSE
    IF Baud = 38400 THEN DlgBaudRate:=4 ELSE
    IF Baud = 57600 THEN DlgBaudRate:=5 ELSE
      DlgBaudRate:=2;
    IF TNC_AN THEN
    BEGIN
      {$IFDEF FLEXNET}
      IF DEVICE=1 THEN
        DlgText(2,2,'PC/FlexNet running, settings obsolete');
      {$ENDIF}
      {$IFDEF WA8DED}
      IF (v24drv.drv_typ=2) AND (device=0) THEN
        DlgText(2,2,'TF-TSR running, settings obsolete');
      {$ENDIF}
    END;
    DlgRadio(2,4,5,1,'COM 1',@_comport);
    DlgRadio(2,5,5,2,'COM 2',@_comport);
    DlgRadio(2,6,5,3,'COM 3',@_comport);
    DlgRadio(2,7,5,4,'COM 4',@_comport);
    DlgRadio(14,4,6,1,'4800',@DlgBaudrate);
    DlgRadio(14,5,6,2,'9600',@DlgBaudrate);
    DlgRadio(14,6,6,3,'19200',@DlgBaudrate);
    DlgRadio(14,7,6,4,'38400',@DlgBaudrate);
    DlgRadio(14,8,6,5,'57600',@DlgBaudrate);
    {$IFNDEF linux}
    Str(_interrupt,DlgData[2]);
    DlgIntStr(51,4,4,@DlgData[2]);
    DlgLabel(30,4,20,'IRQ/Interrupt');
    Str(portaddress,DlgData[3]);
    DlgIntStr(51,5,4,@DlgData[3]);
    DlgLabel(30,5,20,'I/O Address');
   {$ELSE}
     DlgRadio(30,4,26,1,'TFKISS-Socket',@tfkiss_flag);
     DlgRadio(30,5,26,0,'Serial Device',@tfkiss_flag);
     DlgStr(2,10,70,@tfkiss_path);
     DlgLabel(2,9,50,'Path of Serial-Device or TFKISS-Socket');
    {$ENDIF} 
    Str(TNCchan,DlgData[4]);
    DlgIntStr(51,6,4,@DlgData[4]);
    DlgLabel(30,6,20,'Channels');
    DlgOkButton(2,11,1,' OK ');
    DlgAbortButton(8,11,' ABORT ');
    DlgOkButton(18,11,2,'detach TNC');
    DlgTitle(' TNC Setup ');
    DlgInit(3,10,2);
  END;

END;
      

PROCEDURE TNCSettingsDlg_Auswert;
VAR tmp_channels,b:BYTE;
BEGIN
  Which_Dialog:=0;
  VAL(DlgData[2],_interrupt,err);
  VAL(DlgData[3],portaddress,err);
  VAL(DlgData[4],tmp_channels,err);
  CASE DlgBaudrate  OF
    1:Baud:=4800;
    2:Baud:=9600;
    3:Baud:=19200;
    4:Baud:=38400;
    5:Baud:=57600;
  END;
  IF dlgResult=1 THEN
  BEGIN
    IF NOT TNC_AN THEN Attach_TNC
  END
  ELSE
    IF (TNC_AN) and (dlgResult=2) THEN
    BEGIN
      {$IFDEF WA8DED}
      IF device=0 THEN
      BEGIN
        Sendcmd(0,'JHOST0');
        V24Close;
        TNC_AN:=FALSE;
        FOR B:=1 TO TNCchan DO
        BEGIN
          IF KS[b]<>NIL THEN
            HandleDiscon(b,'');
        END;
      END;
      {$ENDIF}
    END;
  IF installing=2 THEN
  BEGIN
    installing:=0;
    GeneralSettingsDlg;
  END;
END;

PROCEDURE GeneraLSettingsDlg;

BEGIN
  Which_Dialog:=7;
  DlgStr(33,2,10,@mycall);
  DlgLabel(2,2,30,'Terminal callsign');
  DlgStr(33,3,10,@boxcall);
  DlgLabel(2,3,30,'Mailbox callsign:');
  DlgStr(33,4,10,@convcall);
  DlgLabel(2,4,30,'Converse callsign:');
  DlgStr(33,5,20,@Beta_Key);
  DlgLabel(2,5,30,'reserved field');
  DlgOkButton(2,7, 1,'  OK   ');
  DlgAbortButton(12,7,' ABORT ');
  DlgTitle('Callsigns');
  DlgInit(10,10,1);
END;

PROCEDURE GeneralSettingsDlg_Auswert;
VAR b:byte;
BEGIN
  Which_Dialog:=0;
  boxcall:=ltrim(rtrim(gross(boxcall)));
  convcall:=ltrim(rtrim(gross(convcall)));
  mycall:=ltrim(rtrim(gross(mycall)));
  IF NOT CheckCall(mycall) THEN
    GeneralsettingsDlg
  ELSE
    for b:=1 to ALlocChans DO
    IF (mcall[b]<>NIL) AND (mcall[b]^='') THEN
      mcall[b]^:=mycall;
END;

PROCEDURE PathSettingsDlg;
BEGIN
  Which_Dialog:=8;
  DlgStr(2,3,60,@qrvpath);
  DlgLabel(2,2,40,'Systemdirectory');
  DlgStr(2,5,60,@savpath);
  DlgLabel(2,4,40,'Savedirectory');
  DlgStr(2,7,60,@rempath);
  DlgLabel(2,6,40,'Remote-Directory');
  DlgStr(2,9,60,@runpath);
  DlgLabel(2,8,40,'Directory for external programs');
  DlgStr(2,11,60,@sevenpath);
  DlgLabel(2,10,40,'Directory for 7+/BIN-save');
  DlgStr(2,13,60,@textpath);
  DlgLabel(2,12,40,'Directory for CTEXT etc');
  DlgStr(2,15,60,@temppath);
  DlgLabel(2,14,40,'Temporary directory (bcrx)');
  DlgStr(2,17,60,@helppath);
  DlgLabel(2,16,40,'Online-Help');
  DlgOkButton(2,18, 1,'  OK   ');
  DlgAbortButton(10,18,' ABORT ');
  DlgTitle('Directories...');
  DlgInit(10,3,1);
END;

PROCEDURE PathSettingsDlg_Auswert;
BEGIN
  Which_Dialog:=0;
END;


PROCEDURE TerminalSettingsDlg;

BEGIN
  Which_Dialog:=9;
  Str(maxring,DlgData[1]);
  DLgIntStr(23,3,3,@dlgdata[1]);
  DlgLabel(2,3,21,'maximal //RING');
  Str(PopUp_Duration,DlgData[2]);
  DLgIntStr(23,4,3,@dlgdata[2]);
  DlgLabel(2,4,21,'PopUp delay');
  DlgCheck(2,6,40,'stay in cmd-mode after CR',@holdcmdmode);
  DlgText(2,8,'Sounds...');
  DlgRadio(2,9,40,0,'never click',@rxclick);
  DlgRadio(2,10,40,1,'click on receive at other chans',@rxclick);
  DlgRadio(2,11,40,2,'click on reveive',@rxclick);
  DlgStr(2,13,40,@promptstr);
  DlgLabel(2,12,30,'Terminal prompt');
  DlgCheck(2,14,15,'ANSI Colors.',@ANSIcolors);
  DlgCheck(2,15,15,'Echo        ',@termecho);
  DlgOkButton(2,17, 1,'  OK   ');
  DlgAbortButton(12,17,' ABORT ');
  DlgTitle('Terminal...');
  DlgInit(10,3,1);
END;

PROCEDURE TerminalSettingsDlg_Auswert;
var b:BYTE;
BEGIN
  Which_Dialog:=0;
  IF DlgResult=1 THEN
  BEGIN
    val(DlgData[1],maxring,err);
    val(DlgData[2],PopUp_Duration,err);
    IF holdcmdmode>0 THEN holdcmdmode:=1;
  END;
END;

PROCEDURE PrioDlg;
BEGIN
  Which_Dialog:=23;
  DlgRadio(2,4,1,1,' ',@send_prio);
  DlgRadio(2,5,1,2,' ',@send_prio);
  DlgRadio(2,6,1,3,' ',@send_prio);
  DlgRadio(2,7,1,4,' ',@send_prio);
  DlgRadio(2,8,1,10,' ',@send_prio);
  DlgRadio(2,9,1,20,' ',@send_prio);
  DlgRadio(10,4,1,1,' ',@poll_prio);
  DlgRadio(10,5,1,2,' ',@poll_prio);
  DlgRadio(10,6,1,3,' ',@poll_prio);
  DlgRadio(10,7,1,4,' ',@poll_prio);
  DlgRadio(10,8,1,10,' ',@poll_prio);
  DlgRadio(10,9,1,20,' ',@poll_prio);
  DlgRadio(18,4,1,1,' ',@screen_prio);
  DlgRadio(18,5,1,2,' ',@screen_prio);
  DlgRadio(18,6,1,3,' ',@screen_prio);
  DlgRadio(18,7,1,4,' ',@screen_prio);
  DlgRadio(18,8,1,10,' ',@screen_prio);
  DlgRadio(18,9,1,20,' ',@screen_prio);
  DlgRadio(25,4,6,1,' 100% ',@handle_prio);
  DlgRadio(25,5,6,2,' 50%',@handle_prio);
  DlgRadio(25,6,6,3,' 33%',@handle_prio);
  DlgRadio(25,7,6,4,' 25%',@handle_prio);
  DlgRadio(25,8,6,10,' 10%',@handle_prio);
  DlgRadio(25,9,6,20,' 5%',@handle_prio);
  DlgText(2,3,'Send');
  DlgText(10,3,'Poll');
  DlgText(18,3,'Screen');
  DlgText(25,3,'Handle');
  DlgOkButton(2,11,1,' OK ');
  DlgAbortButton(7,11,' CANCEL');
  DlgTitle(' prio ');
  DlgInit(10,10,1);
END;

PROCEDURE PrioDlg_Auswert;
BEGIN
  Which_Dialog:=0;
END;

PROCEDURE MonitorDlg;
BEGIN
  Which_Dialog:=24;
  DlgText(2,2,'Monitor:');
  DlgCheck(2,3,40,'decode //COMP',@monidecomp);
  DlgCheck(2,4,40,'decode TCPIP',@monitcpip);
  DlgCheck(2,5,40,'show binary data',@monibin);
  DlgText(2,6,'MoniRPL (DG9EP)');
  DlgCheck(2,7,40,'create *.RPL file',@Moni_rpl_an);
  Str(MONI_RPL_FILE_SIZE DIV 1024,DlgData[2]);
  DlgIntSTr(32,8,5,@DlgData[2]);
  DlgLabel(2,8,30,'Invoke MoniRPL at (Kbytes)');
  DlgCheckBit(2,10,8,'Port 0 ',@monitor_chans,1);
  DlgCheckBit(2,11,8,'Port 1 ',@monitor_chans,2);
  DlgCheckBit(2,12,8,'Port 2 ',@monitor_chans,4);
  DlgCheckBit(2,13,8,'Port 3 ',@monitor_chans,8);
  DlgCheckBit(15,10,8,'Port 4 ',@monitor_chans,16);
  DlgCheckBit(15,11,8,'Port 5 ',@monitor_chans,32);
  DlgCheckBit(15,12,8,'Port 6 ',@monitor_chans,64);
  DlgCheckBit(15,13,8,'Port 15 ',@monitor_chans,$8000);
  DlgCheckBit(2,15,9,'ctl ',@monitor_typ,mon_ctl);
  DlgCheckBit(15,15,9,'i ',@monitor_typ,mon_i);
  DlgCheckBit(28,15,9,'ui ',@monitor_typ,mon_ui);
  DlgOkButton(2,18, 1,'  OK   ');
  DlgAbortButton(12,18,' ABORT ');
  DlgTitle('Monitor...');
  DlgInit(10,3,2);
END;

PROCEDURE MonitorDlg_Auswert;
VAR err:integer;
BEGIN
  Which_Dialog:=0;
  If DlgResult>0 THEN
  BEGIN
    SetMonitor;
    Val(dlgdata[2],MONI_RPL_FILE_SIZE,err);
    MONI_RPL_FILE_SIZE:=1024*MONI_RPL_FILE_SIZE;
  END;
END;

PROCEDURE FlexnetDlg;
BEGIN
  Which_Dialog:=25;
  DlgStr(2,3,60,@BudList);
  DlgLabel(2,2,20,'Calls to ignore:');
  DlgStr(2,5,60,@LinkList);
  DlgLabel(2,4,40,'Calls which will get BUSY:');
  DlgOkButton(2,7,1,'  OK  ');
  DlgAbortButton(12,7,' ABORT ');
  DlgTitle('FlexNet...');
  DlgInit(10,3,2);
END;

PROCEDURE FlexNetDlg_Auswert;
BEGIN
  Which_Dialog:=0;
END;

PROCEDURE ScreenDlg;
BEGIN
  Which_Dialog:=26;
  Zeilen_Save:=_zeilen;
  DLgText(2,2,'Resolution (VGA)');
  DlgRadio(2,3,10,0,'25 Lines',@EGAVGAFont);
  DlgRadio(2,4,10,1,'34 Lines',@EGAVGAFont);
  {DlgRadio(2,5,10,2,'43 Zeilen',@EGAVGAFont);}
  DlgRadio(2,5,10,2,'50 Lines',@EGAVGAFont);
  Str(PopUp_Duration,DlgData[2]);
  DLgIntStr(41,4,3,@dlgdata[2]);
  DlgLabel(20,4,21,'PopUp delay');
  Str(crtsave,DlgData[1]);
  DLgIntStr(41,5,3,@dlgdata[1]);
  DlgLabel(20,5,21,'Screensaver (secs)');
  DlgOkButton(2,15, 1,'  OK   ');
  DlgAbortButton(12,15,' ABORT ');
  DlgTitle('Terminal...');
  DlgInit(10,3,1);
END;

PROCEDURE ScreenDlg_Auswert;
var b:BYTE;diff:Integer;
BEGIN
  Which_Dialog:=0;
  IF DlgResult=1 THEN
  BEGIN
    val(DlgData[1],crtsave,err);
    val(DlgData[2],PopUp_Duration,err);
{$IFNDEF linux}
     setvmode(EGAVGAFont);
{$ENDIF}
     diff:=integer(_zeilen)-Zeilen_Save;
    IF DIFF<>0 THEN
    BEGIN
      qsowinsize:=qsowinsize+diff;
      FOR B:=1 TO AllocChans DO
      BEGIN
        QSOBuf[b]^.Resize(pQsoWin,pQsoWin+qsowinsize);
      END;
      IF pMoni>=pstatus2 THEN
      BEGIN
         inc(pMoni,diff);
         (* dec(MoniWinSize,diff); *)
         monibuf^.resize(pMoni,pMoni+MoniWinSize);
      END;
      IF pstatus2>=pVorschreib THEN
        inc(pstatus2,diff);
      IF pVorschreib>=pStatus1 THEN
        inc(pVorschreib,diff);
      IF pstatus1>=pQsoWin THEN
        inc(pstatus1,diff);
     INC(BigMoniWinSize,diff);
     redrawscreen;
   END;
  END;
END;

PROCEDURE DefaultRemotesDlg;
BEGIN
  Which_Dialog:=34;
  DlgCheckBit(2,2,20,'QUIT',@default_remotes,RM1_QUIT);
  DlgCheckBit(2,3,20,'RING',@default_remotes,RM1_RING);
  DlgCheckBit(2,4,20,'ECHO',@default_remotes,RM1_ECHO);
  DlgCheckBit(2,5,20,'RTT',@default_remotes,RM1_RTT);
  DlgCheckBit(2,6,20,'INFO',@default_remotes,RM1_INFO);
  DlgCheckBit(2,7,20,'CSTATUS',@default_remotes,RM1_CS);
  DlgCheckBit(2,8,20,'USER',@default_remotes,RM1_USER);
  DlgCheckBit(2,9,20,'HELP',@default_remotes,RM1_HELP);
  DlgCheckBit(2,10,20,'SYSOP',@default_remotes,RM1_SYSOP);
  DlgCheckBit(2,11,20,'DIR',@default_remotes,RM1_DIR);
  DlgCheckBit(2,12,20,'READ',@default_remotes,RM1_READ);
  DlgCheckBit(2,13,20,'WRITE',@default_remotes,RM1_WRITE);
  DlgCheckBit(2,14,20,'RPRG',@default_remotes,RM1_RPRG);
  DlgCheckBit(2,15,20,'WPRG',@default_remotes,RM1_WPRG);
  DlgCheckBit(36,2,20,'NAME',@default_remotes,RM1_NAME);
  DlgCheckBit(36,3,20,'MHEARD',@default_remotes,RM1_MH);
  DlgCheckBit(36,4,20,'RUN',@default_remotes,RM1_RUN);
  DlgCheckBit(36,5,20,'BOX',@default_remotes,RM1_BOX);
  DlgCheckBit(36,6,20,'DOS',@default_remotes,RM1_DOS);
  DlgCheckBit(36,7,20,'NODE',@default_remotes,RM1_NODE);
  DlgCheckBit(36,8,20,'CONNECT',@default_remotes,RM1_CONNECT);
  DlgCheckBit(36,9,20,'COMPRESS',@default_remotes,RM1_COMPRESS);
  DlgCheckBit(36,10,20,'VERSION',@default_remotes,RM1_VERSION);
  DlgCheckBit(36,11,20,'TIME',@default_remotes,RM1_TIME);
  DlgCheckBit(36,12,20,'XRUN',@default_remotes,RM1_XRUN);
  DlgCheckBit(36,13,20,'REBOOT',@default_remotes,RM1_REBOOT);
  DlgCheckBit(36,14,20,'TNC',@default_remotes,RM1_TNC);
  DlgCheckBit(36,15,20,'FORCE',@default_remotes,RM1_FORCE);
  DlgCheckBit(36,16,20,'CONVERS',@default_remotes,RM1_CONVERS);
  DlgOkButton(2,17,1,'   OK  ');
  DlgABortButton(26,17,' Abort ');
  DlgTitle('Allowed remotes for unknown Stn');
  DlgInit(5,2,1);
END;

PROCEDURE DefaultRemotesDlg_Auswert;
BEGIN
END;

END.
